<?php

require_once($GLOBALS['babInstallPath'].'admin/acl.php');
require_once(dirname(__FILE__) . '/nlincl.php');
require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');



function setManagerGroup()
{
	global $babBody;

	$babBody->title = nl_translate("Define newsletter managers");
	$babBody->addItemMenu('List', nl_translate("List"), nl_url().'admin&idx=List');
	$babBody->addItemMenu('Create', nl_translate("Create"), nl_url().'admin&idx=Create');
	$babBody->addItemMenu('Acl', nl_translate("Define right"), nl_url().'admin&idx=Acl');

	$macl = new macl('addon/newsletter'.'/admin', "List", $_GET['id'], 'Aclview');
	$macl->addtable(NL_MANAGERS_GROUP, $babBody->title);
	$macl->filter(ENABLE_GROUP, ENABLE_GROUP, DISABLE_GROUP, ENABLE_GROUP, DISABLE_GROUP);

	$macl->babecho();
}


function listAllNewsletters()
{
	$query = 'SELECT DISTINCT id, name, description FROM ' . NL_NEWSLETTER_TOPIC . ' order by name asc';

	//bab_debug($query);
	$newsletters = new NewsletterInfo($query);
	
	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('edit_url', nl_url() . 'admin&idx=Edit&id=');
	
	$newsletters->set_anchor(nl_url() . 'admin&idx=Acl&id=',
		$GLOBALS['babSkinPath'] . 'images/Puces/manager.gif',
		nl_translate("Define newsletter managers")
		);
	$newsletters->set_anchor(nl_url() . 'admin&idx=Edit&id=',
		$GLOBALS['babSkinPath'] . 'images/Puces/FileWrite.gif',
		nl_translate("Edit")
		);
	$newsletters->set_anchor(nl_url() . 'admin&idx=Delete&id=',
		$GLOBALS['babSkinPath'] . 'images/Puces/del.gif',
		nl_translate("Delete")
		);

	global $babBody;
	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'common.html', 'nlList'));

	$babBody->title = nl_translate("Newsletter list");

	$babBody->addItemMenu('List', nl_translate("List"), nl_url().'admin&idx=List');
	$babBody->addItemMenu('Create', nl_translate("Create"), nl_url().'admin&idx=Create');
	$babBody->addItemMenu("Manage", nl_translate("Manage"), nl_url()."admin&idx=Manage");
}


function createEditNewsletter($newpc=false)
{
	$baseFormProcessing = new BaseFormProcessing();

	$baseFormProcessing->set_caption('name', nl_translate("Name"));
	$baseFormProcessing->set_caption('description', nl_translate("Description"));
	$baseFormProcessing->set_caption('smtp_msg_sent_by_loop', nl_translate("Maximum number of receivers by e-mail messenger"));
	$baseFormProcessing->set_caption('send_method', nl_translate("Send method"));
	$baseFormProcessing->set_caption('a', nl_translate("Individual"));
	$baseFormProcessing->set_caption('bcc', nl_translate("Grouped"));
	
	$newsletterInfo = array();

	$action = 'Edit';
	
	if(isset($_GET['id']) && !$newpc)
	{
		$baseFormProcessing->set_caption('submit', nl_translate("Update"));
		$baseFormProcessing->set_caption('title', nl_translate("Newsletter modifcation"));
		$baseFormProcessing->set_caption('action', nl_translate("Edit"));

		//Edition
		$newsletterInfo = array('id' => $_GET['id'], 'name' => '', 'description' => '', 
			'smtp_msg_sent_by_loop' => 0, 'send_method' => 0);

		$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);
		$newsletterInfo = $tableWrapper->load($newsletterInfo, 0, 5, 0, 1);
	}
	else if(isset($_POST['id']) && !$newpc)
	{
		$baseFormProcessing->set_caption('submit', $_POST['Submit']);
		$baseFormProcessing->set_caption('title', nl_translate("Newsletter modifcation"));
		$baseFormProcessing->set_caption('action', $_POST['action']);

		$newsletterInfo = array(	
			'id' => $_POST['id'], 
			'name' => (isset($_POST['name'])) ? nl_stripSlashes($_POST['name']) : '',
			'description' => (isset($_POST['description'])) ? nl_stripSlashes($_POST['description']) : '',
			'smtp_msg_sent_by_loop' => (isset($_POST['smtp_msg_sent_by_loop'])) ? $_POST['smtp_msg_sent_by_loop'] : 1,
			'send_method' => (isset($_POST['send_method'])) ? $_POST['send_method'] : A_SEND_METHOD
			);
	}
	else
	{
		$action = 'Create';

		$baseFormProcessing->set_caption('submit', nl_translate("Create"));
		$baseFormProcessing->set_caption('title', nl_translate("Newsletter creation"));
		$baseFormProcessing->set_caption('action', nl_translate("Create"));

		//creation
		$newsletterInfo = array(	
			'id' => -1, 
			'name' => '',
			'description' => '',
			'smtp_msg_sent_by_loop' => 30,
			'send_method' => A_SEND_METHOD
			);
	}

	//$baseFormProcessing->get_caption('action', $action);
	$baseFormProcessing->get_caption('title', $babBody->title);
	$baseFormProcessing->set_error('name', nl_translate("The field name must not be empty"));
	$baseFormProcessing->implode_errors(',',true);

	$baseFormProcessing->set_data('action', $action);

	if(false !== $newsletterInfo)
	{
		while(list($key, $val) = each($newsletterInfo)) 
		{
			$baseFormProcessing->set_data($key, $val);
		}

		$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);
		$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

		global $babBody;
		$babBody->addItemMenu('List', nl_translate("List"), nl_url().'admin&idx=List');
		$babBody->addItemMenu($action, nl_translate($action), nl_url().'admin&idx=' . $action);
		$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'admin.html',  'nlAdminEditCreate'));
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("ERROR : Cannot Edit/Create a newsletter");
	}
}


function manageNewsletter(){
	global $babBody;
	
	$baseFormProcessing = new BaseFormProcessing();

	$baseFormProcessing->set_caption('size_t', nl_translate("Total size of image"));
	$baseFormProcessing->set_caption('submit', nl_translate("Save"));
	$baseFormProcessing->set_caption('title', nl_translate("Newsletter management"));
	$baseFormProcessing->set_caption('record', nl_translate("Save"));

	//creation

	//$baseFormProcessing->get_caption('action', $action);
	$babBody->title = nl_translate("Newsletter management");
	
	$registry = bab_getRegistryInstance();
	$registry->changeDirectory('/newsletter');
	$value = $registry->getValue('size', 0);
	$baseFormProcessing->set_data('size', $value);


	$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);
	$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

	global $babBody;
	$babBody->addItemMenu('List', nl_translate("List"), nl_url().'admin&idx=List');
	$babBody->addItemMenu('Create', nl_translate("Create"), nl_url().'admin&idx=Create');
	$babBody->addItemMenu("Manage", nl_translate("Manage"), nl_url()."admin&idx=Manage");

	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'admin.html',  'nlAdminManage'));
	
	
}

function processCreateEditNewsletter($action)
{
	$nameerror = $_POST['name'];
	$name = (true == isset($_POST['name'])) ? nl_escapeString($_POST['name']) : '';
	
	if('' !== $name || strlen($name) > 0)
	{
		$description = (true == isset($_POST['description'])) ? nl_escapeString($_POST['description']) : '';

		$attributs = array('id' => (true == isset($_POST['id'])) ? $_POST['id'] : 0, 
			'name' => $name, 
			'description' => $description,
			'smtp_msg_sent_by_loop' => (true == isset($_POST['smtp_msg_sent_by_loop'])) ? $_POST['smtp_msg_sent_by_loop'] : 1,
			'send_method' => (true == isset($_POST['send_method']) && "grouped" == $_POST['send_method']) ? BCC_SEND_METHOD : A_SEND_METHOD);

		$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);

		if('Create' == $action)
		{
			//Si il n'existe pas dja
			if(false === $tableWrapper->load($attributs, 0, 1, 1, 1))
			{
				//Default values
				$msg = nl_translate(" goes here");
				$attributs['creation_date']				= 'now()';
				$attributs['admin_name']				= nl_escapeString($GLOBALS['babAdminName']);
				$attributs['admin_email']				= nl_escapeString($GLOBALS['babAdminEmail']);

				$attributs['letter_header']				= nl_escapeString(nl_translate("Letter header") . $msg);
				$attributs['letter_footer']				= nl_escapeString(nl_translate("Letter footer") . $msg);
				$attributs['subscription_subject']		= nl_escapeString(nl_translate("Subscription subject") . $msg);
				$attributs['subscription_body']			= nl_escapeString(nl_translate("Subscription body") . $msg);
				$attributs['welcome_subject']			= nl_escapeString(nl_translate("Welcome message") . $msg);
				$attributs['welcome_body']				= nl_escapeString(nl_translate("Welcome message body") . $msg);
				$attributs['quit_subject']				= nl_escapeString(nl_translate("Quit message") . $msg);
				$attributs['quit_body']					= nl_escapeString(nl_translate("Quit message body") . $msg);
				$attributs['unsubscription_subject']	= nl_escapeString(nl_translate("Unsubscription confirmation") . $msg);
				$attributs['unsubscription_body']		= nl_escapeString(nl_translate("Unsubscription body") . $msg);
				$attributs['subscription_validation']	= SUBSCRIPTION_NEEDED;
				$attributs['unsubscription_validation'] = UNSUBSCRIPTION_NEEDED;  
	
				if(false == $tableWrapper->save($attributs, true, true))
				{
					$GLOBALS['babBody']->msgerror = nl_translate("Error while saving");
					return false;
				}
			}
			else
			{
				$GLOBALS['babBody']->msgerror = nl_translate("The newsletter ");
				$GLOBALS['babBody']->msgerror .= $nameerror;
				$GLOBALS['babBody']->msgerror .= nl_translate(" already exist");
				return false;
			}
		}
		else if('Edit' == $action)
		{
			if(false == $tableWrapper->update($attributs))
			{
				$GLOBALS['babBody']->msgerror = nl_translate("Error while updating");
				return false;
			}
		}
		return true;
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("The field name must not be empty");
		return false;
	}
}

function deleteNewsletter()
{
	global $babBody;
	$babBody->addItemMenu("List", nl_translate("List"), nl_url()."admin&idx=List");
	$babBody->addItemMenu("Create", nl_translate("Create"), nl_url()."admin&idx=Create");
	$babBody->addItemMenu("Manage", nl_translate("Manage"), nl_url()."admin&idx=Manage");


	$newsletterInfo	= array('id' => $_GET['id'], 'name' => '');
	$tableWrapper	= new TableWrapper(NL_NEWSLETTER_TOPIC);
	$newsletterInfo	= $tableWrapper->load($newsletterInfo, 0, 2, 0, 1);


	if(false !== $newsletterInfo)
	{
		$baseFormProcessing = new BaseFormProcessing();

		$baseFormProcessing->set_caption('msg', nl_translate("Are you sure you want to delete this newsletter ? :"));
		$baseFormProcessing->set_caption('warning', 
			nl_translate("WARNING: This operation will delete this newsletter with all references !"));
		$baseFormProcessing->set_caption('yes', nl_translate("Yes"));
		$baseFormProcessing->set_caption('no', nl_translate("No"));

		$baseFormProcessing->set_data('id', $newsletterInfo['id']);
		$baseFormProcessing->set_data('name', $newsletterInfo['name']);
		$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);

		$babBody->addItemMenu("Delete", nl_translate("Delete"), nl_url()."admin&idx=List");

		$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath()."admin.html",  "warningyesno"));
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("ERROR : Cannot load the newsletter");
	}
}

function processDeleteNewsletter()
{
	if(isset($_GET['id']))
	{
		$db = &$GLOBALS['babDB'];

		$query = 'DELETE FROM ' . NL_NEWSLETTER_TOPIC . ' WHERE id = \'' . $_GET['id'] . '\'';
		$db->db_query($query);

		$query = 'DELETE FROM ' . NL_LETTERS . ' WHERE id_newsletter_topic = \'' . $_GET['id'] . '\'';
		$db->db_query($query);

		$query = 'DELETE FROM ' . NL_SUBSCRIBERS . ' WHERE id_newsletter_topic = \'' . $_GET['id'] . '\'';
		$db->db_query($query);

		$query = 'DELETE FROM ' . NL_MANAGERS_GROUP . ' WHERE id_object = \'' . $_GET['id'] . '\'';
		$db->db_query($query);

		$query = 'DELETE FROM ' . NL_WRITERS_GROUP . ' WHERE id_object = \'' . $_GET['id'] . '\'';
		$db->db_query($query);

		$query = 'DELETE FROM ' . NL_USERS_GROUP . ' WHERE id_object = \'' . $_GET['id'] . '\'';
		$db->db_query($query);
	}
}

function processManageLetter()
{
	$registry = bab_getRegistryInstance();
	$registry->changeDirectory('/newsletter');
	$registry->setKeyValue('size', bab_pp('size', 0));
}

/* main */
$g_idx = isset($_POST['idx']) ? $_POST['idx'] : (isset($_GET['idx']) ? $_GET['idx'] : 'List');

$action = isset($_POST['action']) ? $_POST['action'] : 
	(isset($_GET['action']) ? $_GET['action'] :  
	(isset($_POST['Aclview']) ? 'Aclview' : '')
	);

$newpc = false; //pour recrer la newsletter si une avait dj le mme nom	
	
switch($action)
{
	case 'Aclview':
		maclGroups();
		break;

	case 'DeletionConfirmed':
		processDeleteNewsletter();
		break;

	case 'managed':
		processManageLetter();
		break;

	case 'Edit':
	case 'Create':
		if(false == processCreateEditNewsletter($action))
		{
			$g_idx = $_POST['action'];
			//La lettre n'a pas pu tre cre
			$newpc = true;
		}
		break;
}


switch($g_idx)
{
	case 'Acl':
		setManagerGroup();
		break;

	case 'Edit':
	case 'Create':
		createEditNewsletter($newpc);
		break;

	case 'Delete':
		deleteNewsletter();
		break;
		
	case 'Manage':
		manageNewsletter();
		break;

	case 'List':
	default:
		listAllNewsletters();
		break;
}

$babBody->setCurrentItemMenu($g_idx);

?>