<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2006 by CANTICO ({@link http://www.cantico.fr})
 */
require_once 'base.php';
require_once dirname(__FILE__) . '/multipage.class.php';


class NL_UserNlListDataSource extends NL_MySqlDataSource
{
	protected $ids = null;
	
	
	function NL_UserNlListDataSource($ids = null)
	{
		$this->ids = $ids;
		parent::NL_MySqlDataSource();
	}
	
	function init($sQuery)
	{
		global $babDB;
		
		$aTopicId		= array_keys(bab_getUserIdObjects(NL_USERS_GROUP));
		$aColumn		= array();
		$aWhereClause	= array();
		
		$aWhereClause[] = 'nl.id IN(\'' . implode("','", $aTopicId) . '\')';
		$aWhereClause[] = 'nl.disabled != 1';
		if($this->ids){
			$aWhereClause[] = 'nl.id IN('.$babDB->quote($this->ids).')';
		}

		$sLeftJoin = '';
		
		if(true === bab_userIsloggedin())
		{
			$sLeftJoin = ' AND sus.id_ov_user = ' . $babDB->quote($GLOBALS['BAB_SESS_USERID']);
		}
		
		$sSearch = (string) bab_rp('sSearch', '');
		if('' !== $sSearch)
		{
			$aWhereClause[] = 'nl.name LIKE \'%' . $babDB->db_escape_like($sSearch) . '%\'';
			$aWhereClause[] = 'nl.description LIKE \'%' . $babDB->db_escape_like($sSearch) . '%\'';
		}	
		
		$sQuery =
			'SELECT ' . 
				'nl.id iId, ' .
				'nl.name sName, ' .
				'nl.description sDescription, ' .
				'IFNULL(sus.id_ov_user, 0) idUserSus, ' .
				'IFNULL(sus.id, 0) iIdSus ' .
			'FROM ' . 
				NL_NEWSLETTER_TOPIC . ' nl ' .
			'LEFT JOIN ' . 
				NL_SUBSCRIBERS .  ' sus ON sus.id_newsletter_topic = nl.id ' . $sLeftJoin . ' ' .
			'WHERE ' .
				implode(' AND ', $aWhereClause) . ' ' .
			'GROUP BY ' .
				'name ' .
			'ORDER BY ' . 
				'name ' .
			'ASC';
		
		parent::init($sQuery);	
	}
}
