<?php

require_once(dirname(__FILE__) . '/nlincl.php');

function newsletter_getAdminSectionMenus(&$url, &$text)
{
    static $nbMenus=0;
	if( !$nbMenus )
	{
		$url = nl_url()."admin&idx=List";
		$text = bab_translate("Newsletter",'newsletter');
		$nbMenus++;
		return true;
	}
	return false;
	
}

function newsletter_onSectionCreate(&$title, &$content)
{
	return false;
}

function newsletter_onUserDelete( $id )
{
	$db = & $GLOBALS['babDB'];

	$query = 'DELETE FROM ' . NL_SUBSCRIBERS . ' WHERE  id_ov_user = \'' . $id . '\'';
	$db->db_query($query);
}

function newsletter_onUserCreate( $id )
{
}


function newsletter_onGroupDelete( $id )
{
}

function newsletter_onGroupCreate( $id )
{
}


function newsletter_getUserSectionMenus(&$url, &$text)
{    
    static $nbMenus=0;

	if( !$nbMenus && 0 != getUserAccess() )
	{
		$url = nl_url()."users&idx=defaultMenu";
		$text = bab_translate("Newsletter",'newsletter');
		$nbMenus++;
		return true;
	}
	return false;
}

function newsletter_upgrade($version_base,$version_ini)
{
	// register the event listener
	require_once $GLOBALS['babInstallPath']."utilit/eventincl.php";
	bab_addEventListener('bab_eventEditors', 'newsletter_getEditorDetails', 'addon/newsletter/events.php', 'newsletter', 0);
	bab_addEventListener('bab_eventAfterMailSent', 'newsletter_onAfterMailSent'	, 'addons/newsletter/events.php', 'newsletter');
	
	global $babBody;
	$db = & $GLOBALS['babDB'];

	if(!bab_isTable('nl_letter'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_letter` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_newsletter_topic` int(11) default NULL,
			`id_writer` int(11) default NULL,
			`creation_date` datetime default NULL,
			`date_envoi` datetime default NULL,
			`subject` text,
			`body` longtext,
			`hash` varchar(255) default NULL,
			PRIMARY KEY  (`id`))
			");
	}

	if(!bab_isTable('nl_letter_subscribers'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_letter_subscribers` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_letter` int(11) default NULL,
			`id_subscribers` int(11) default NULL,
			`hash` varchar(255) default NULL,
			PRIMARY KEY  (`id`))
			");
	}

	if(!bab_isTable('nl_managers_groups'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_managers_groups` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_object` int(11) unsigned NOT NULL default '0',
			`id_group` int(11) unsigned NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_object` (`id_object`),
			KEY `id_group` (`id_group`))
			");
	}

	if(!bab_isTable('nl_newsletter_topic'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_newsletter_topic` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`name` varchar(255) NOT NULL default '',
			`description` varchar(255) NOT NULL default '',
			`admin_name` varchar(255) NOT NULL default '',
			`admin_email` varchar(255) NOT NULL default '',
			`img_insertion` TINYINT NOT NULL DEFAULT '1',
			`template` VARCHAR( 255 ) NOT NULL DEFAULT 'default_letter',
			`creation_date` datetime NOT NULL default '0000-00-00 00:00:00',
			`letter_header` text NOT NULL,
			`letter_footer` text NOT NULL,
			`subscription_subject` text NOT NULL,
			`subscription_body` longtext NOT NULL,
			`welcome_subject` text NOT NULL,
			`welcome_body` longtext NOT NULL,
			`quit_subject` text NOT NULL,
			`quit_body` longtext NOT NULL,
			`unsubscription_subject` text NOT NULL,
			`unsubscription_body` longtext NOT NULL,
			`smtp_msg_sent_by_loop` tinyint(4) NOT NULL default '0',
			`send_method` tinyint(4) NOT NULL default '1',
			`subscription_validation_period` tinyint(4) NOT NULL default '0',
			`disabled` tinyint(4) NOT NULL default '0',
			`subscription_validation` tinyint(4) NOT NULL default '0',
			`unsubscription_validation` tinyint(4) NOT NULL default '0',
			`subscription_moderation` tinyint(4) NOT NULL default '0',
			PRIMARY KEY  (`id`))
			");
	}

	if(!nl_isTableField('nl_newsletter_topic', 'img_insertion')){
		$query = "ALTER TABLE `nl_newsletter_topic` ADD `img_insertion` TINYINT NOT NULL DEFAULT '1' AFTER `admin_email`";
		$result = $db->db_query($query);
	}

	if(!nl_isTableField('nl_newsletter_topic', 'template')){
		$query = "ALTER TABLE `nl_newsletter_topic` ADD `template` VARCHAR( 255 ) NOT NULL DEFAULT 'default_letter' AFTER `img_insertion`";
		$result = $db->db_query($query);
	}

	if(!nl_isTableField('nl_newsletter_topic', 'patron')){
		$query = "ALTER TABLE `nl_newsletter_topic` ADD `patron` VARCHAR( 255 ) NOT NULL DEFAULT 'default_letter' AFTER `template`";
		$result = $db->db_query($query);
		$query = "ALTER TABLE  `nl_newsletter_topic` CHANGE  `template`  `template` VARCHAR( 255 ) NOT NULL DEFAULT  ''";
		$result = $db->db_query($query);
		$query = "UPDATE `nl_newsletter_topic` SET `template` = ''";
		$result = $db->db_query($query);
	}
	
	if (!bab_isTable("nl_subscribers"))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_subscribers` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_ov_user` int(11) unsigned NOT NULL default '0',
			`id_newsletter_topic` int(11) unsigned NOT NULL default '0',
			`first_name` varchar(255) NOT NULL default '',
			`last_name` varchar(255) NOT NULL default '',
			`email` varchar(255) NOT NULL default '',
			`subscription_date` datetime NOT NULL default '0000-00-00 00:00:00',
			`subscription` tinyint(4) NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_ov_user` (`id_ov_user`),
			KEY `id_newsletter_topic` (`id_newsletter_topic`))
			");
	}
	else
	{
		$query = 'SHOW COLUMNS FROM nl_subscribers LIKE \'subscription_confirmed\'';
		$result = $db->db_query($query);
	
		if(false != $result)
		{
			$column = $db->db_fetch_array($result);
			if(false != $column)
			{
				$query = 'ALTER TABLE `nl_subscribers` CHANGE `subscription_confirmed` `subscription` TINYINT( 4 ) DEFAULT \'0\' NOT NULL';
				$result = $db->db_query($query);
			}
		}
	}

	if(!bab_isTable('nl_subscribers_tmp'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_subscribers_tmp` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_ov_user` int(11) unsigned NOT NULL default '0',
			`id_newsletter_topic` int(11) unsigned NOT NULL default '0',
			`first_name` varchar(255) NOT NULL default '',
			`last_name` varchar(255) NOT NULL default '',
			`email` varchar(255) NOT NULL default '',
			`subscription_date` datetime NOT NULL default '0000-00-00 00:00:00',
			`subscription` tinyint(4) NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_ov_user` (`id_ov_user`),
			KEY `id_newsletter_topic` (`id_newsletter_topic`))
			");
	}

	if(!bab_isTable('nl_users_groups'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_users_groups` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_object` int(11) unsigned NOT NULL default '0',
			`id_group` int(11) unsigned NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_object` (`id_object`),
			KEY `id_group` (`id_group`))
			");
	}

	if(!bab_isTable('nl_writers_groups'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_writers_groups` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_object` int(11) unsigned NOT NULL default '0',
			`id_group` int(11) unsigned NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_object` (`id_object`),
			KEY `id_group` (`id_group`))
			");
	}

	if(!bab_isTable('nl_inscription_groups'))
	{
		$res[] = $db->db_query("
			CREATE TABLE `nl_inscription_groups` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`id_object` int(11) unsigned NOT NULL default '0',
			`id_group` int(11) unsigned NOT NULL default '0',
			PRIMARY KEY  (`id`),
			KEY `id_object` (`id_object`),
			KEY `id_group` (`id_group`))
			");
	}
	
	@bab_functionality::includefile('PortletBackend');
	if (class_exists('Func_PortletBackend')) {
		$addonName = 'newsletter';
		$addonInfo = bab_getAddonInfosInstance($addonName);
	
		$addonPhpPath = $addonInfo->getPhpPath();
		require_once $GLOBALS['babInstallPath'].'utilit/functionalityincl.php';
		$functionalities = new bab_functionalities();
		$functionalities->registerClass('Func_PortletBackend_Newsletter', $addonPhpPath . 'portletbackend.class.php');
	}
	
	if (!bab_isTableField('nl_letter_subscribers', 'sent_status'))
	{
		$db->db_query("ALTER TABLE nl_letter_subscribers ADD `sent_status` tinyint(1) unsigned default NULL COMMENT 'null=waiting, 0=failed, 1=sent'");
	}
	
	if (!bab_isTableField('nl_letter_subscribers', 'error_msg'))
	{
		$db->db_query("ALTER TABLE nl_letter_subscribers ADD `error_msg` varchar(255) NOT NULL default ''");
	}

	return true;
}


?>