<?php
require_once($GLOBALS['babInstallPath'].'admin/acl.php');
require_once(dirname(__FILE__) . '/nlincl.php');
require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');


/*
	Manager function:
		Liste toutes les newsletters pour lesquelles
		l'utilisateur courant est un manager
*/
function listManagerNewsletters()
{
	$query =
		'SELECT ' .
			'nl.id, ' .
			'name, ' .
			'description ' .
		'FROM ' .
			NL_NEWSLETTER_TOPIC . ' nl ' .
		'WHERE ' .
			'nl.id IN(\'' . implode("','", array_keys(bab_getUserIdObjects(NL_MANAGERS_GROUP))) . '\') ' .
		'ORDER BY ' .
			'name ' .
		'ASC';

	//echo $query . '<br />';

	$newsletters = new NewsletterInfo($query);

	$nl_addonInfo = nl_addonInfo();

	$newsletters->set_anchor(nl_url() . 'users&idx=aclWriter&id=',
		$nl_addonInfo->getImagesPath() . '16x16/user-properties.png',
		nl_translate("Define newsletter add-on writers")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=aclUser&id=',
		$nl_addonInfo->getImagesPath() . '16x16/preferences-authentication.png',
		nl_translate("Define newsletter add-on suscribers and how")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=edit&id=',
		$nl_addonInfo->getImagesPath() . '16x16/preferences-other.png',
		nl_translate("Parameters")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=ImportExportUsers&id=',
		$nl_addonInfo->getImagesPath() . '16x16/document-download.png',
		nl_translate(" Import/Export some subscribers")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=listSubscribers&page=1&filter=All&attribut='
		. FIRSTNAME . '&order=' . ORDER_ASC .  '&research_type=' . NORMAL_RESEARCH . '&topic_id=',
		$nl_addonInfo->getImagesPath() . '16x16/group.png',
		nl_translate("List of the subscribers")
	);

	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('edit_url', nl_url() . 'users&idx=edit&id=');

	global $babBody;
	$babBody->title = nl_translate("Newsletter that you manage");
	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'common.html', 'nlList'));

	addDefaultMenu();
}


function listSubscribers()
{
	$baseFormProcessing = new SubscriberList('');

	$baseFormProcessing->set_caption('advanced_title', nl_translate("Advanced research"));
	$baseFormProcessing->set_data('advanced_url', 'javascript:goto_advanced_research();');


	global $babBody;
	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'listSubscribers'));

	addDefaultMenu();
	$babBody->addItemMenu("listSubscribers",
			nl_translate("List of the subscribers"), "");
}

function display_advanced_research_form()
{
	$baseFormProcessing = new BaseFormProcessing;

	$baseFormProcessing->set_data('page', $_POST['page']);
	$baseFormProcessing->set_data('filter', $_POST['filter']);
	$baseFormProcessing->set_data('attribut', $_POST['attribut']);
	$baseFormProcessing->set_data('order', $_POST['order']);
	$baseFormProcessing->set_data('research_type', $_POST['research_type']);
	$baseFormProcessing->set_data('topic_id', $_POST['topic_id']);

	$baseFormProcessing->set_data('first_name', $_POST['first_name']);
	$baseFormProcessing->set_data('last_name', $_POST['last_name']);
	$baseFormProcessing->set_data('email', $_POST['email']);
	$baseFormProcessing->set_data('begin_date', $_POST['begin_date']);
	$baseFormProcessing->set_data('begin_date_sign', $_POST['begin_date_sign']);
	$baseFormProcessing->set_data('end_date', $_POST['end_date']);
	$baseFormProcessing->set_data('end_date_sign', $_POST['end_date_sign']);
	$baseFormProcessing->set_data('subscription', $_POST['subscription']);

	$baseFormProcessing->set_caption('advanced_research', nl_translate("Advanced research"));
	$baseFormProcessing->set_caption('subscription_date', nl_translate("Subscription date"));
	$baseFormProcessing->set_caption('date_format', nl_translate("( yyyy-dd-mm )"));
	$baseFormProcessing->set_caption('begin_date', nl_translate("Begin date"));
	$baseFormProcessing->set_caption('end_date', nl_translate("End date"));
	$baseFormProcessing->set_caption('first_name', nl_translate("First Name"));
	$baseFormProcessing->set_caption('last_name', nl_translate("Last Name"));
	$baseFormProcessing->set_caption('email', nl_translate("Email"));
	$baseFormProcessing->set_caption('subscription', nl_translate("Subscription"));
	$baseFormProcessing->set_caption('subscription_to_confirm', nl_translate("Subscription to confirm"));
	$baseFormProcessing->set_caption('subscription_confirmed', nl_translate("Subscription confirmed"));
	$baseFormProcessing->set_caption('unsubscription_to_confirm', nl_translate("Unsubscription to confirm"));
	$baseFormProcessing->set_caption('unsubscription_confirmed', nl_translate("Unsubscription confirmed"));
	$baseFormProcessing->set_caption('nb_results', nl_translate("Number of result per page"));
	$baseFormProcessing->set_caption('results', nl_translate("results"));
	$baseFormProcessing->set_caption('search', nl_translate("Search"));
	$baseFormProcessing->set_caption('reset', nl_translate("Reset"));
	$baseFormProcessing->set_caption('back', nl_translate("Back"));

	global $babBody;
	addDefaultMenu();
	$babBody->addItemMenu('advanced_research', nl_translate("Advanced research"), nl_url().'users&idx=advanced_research');

	$babBody->title = nl_translate("Advanced research");

	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'advanced_research'));

}

/*
	Manager function:
		Edition d'une newsletter
*/
function editNewsletter()
{
	class editNewsLetterClass extends BaseFormProcessing
	{

		function get_next_template()
		{
			static $i = 0;
			static $enter = false;

			if($enter === false){
				$enter = true;
				$this->template_name_txt = nl_translate('None');
				$this->template_name = '';
				if( $this->template_name == $this->m_datas['template'] ){
					$this->arttmplselected = 'selected="selected"';
				}else{
					$this->arttmplselected = "";
				}
				return true;
			}

			if($i < $this->countnltmpl)
			{
				$this->template_name = $this->arrnltmpl[$i];
				$this->template_name_txt = $this->template_name;
				if( $this->template_name == $this->m_datas['template'] ){
					$this->arttmplselected = 'selected="selected"';
				}else{
					$this->arttmplselected = "";
				}
				$i++;
				return true;
			}
			return false;
		}

		function get_next_patron()
		{
			static $i = 0;
			if($i < $this->countnlpatron)
			{
				$this->patron_name = $this->arrnlpatron[$i];
				if( $this->patron_name == $this->m_datas['patron'] ){
					$this->artpatronselected = 'selected="selected"';
				}else{
					$this->artpatronselected = "";
				}
				$i++;
				return true;
			}
			return false;
		}

		function editNewsLetterClass()
		{
			parent::BaseFormProcessing();

			$this->arrnlpatron = array();

			$file = "newsletter_patron.html";
			$filepath = "skins/".$GLOBALS['babSkin']."/templates/". $file;
			if( !file_exists( $filepath ) )
			{
				$filepath = $GLOBALS['babSkinPath']."templates/". $file;
				if( !file_exists( $filepath ) )
				{
					$filepath = $GLOBALS['babInstallPath'].'skins/ovidentia/templates/'.nl_relativePath(). $file;
				}
			}
			if( file_exists( $filepath ) )
			{
				$tpl = new bab_Template();
				$arr = $tpl->getTemplates($filepath);
				for( $i=0; $i < count($arr); $i++)
				{
					$this->arrnlpatron[] = $arr[$i];
				}
			}
			$this->countnlpatron = count($this->arrnlpatron);

			$this->arrnltmpl = array();

			$file = "newsletter_template.html";
			$filepath = "skins/".$GLOBALS['babSkin']."/templates/". $file;
			if( !file_exists( $filepath ) )
			{
				$filepath = $GLOBALS['babSkinPath']."templates/". $file;
				if( !file_exists( $filepath ) )
				{
					$filepath = $GLOBALS['babInstallPath'].'skins/ovidentia/templates/'.nl_relativePath(). $file;
				}
			}
			if( file_exists( $filepath ) )
			{
				$tpl = new bab_Template();
				$arr = $tpl->getTemplates($filepath);
				for( $i=0; $i < count($arr); $i++)
				{
				$this->arrnltmpl[] = $arr[$i];
				}
			}
			$this->countnltmpl = count($this->arrnltmpl);
		}
	}

	$baseFormProcessing = new editNewsLetterClass();

	$baseFormProcessing->set_caption('id', nl_translate("Identifier"));
	$baseFormProcessing->set_caption('name', nl_translate("Name"));
	$baseFormProcessing->set_caption('letter_header', nl_translate("Edition of the headline of the letter"));
	$baseFormProcessing->set_caption('letter_footer', nl_translate("Edition of the foot of page of the letter"));

	$baseFormProcessing->set_caption('img_insertion_t', nl_translate("Image insertion mode"));
	$baseFormProcessing->set_caption('embedded', nl_translate("Embedded"));
	$baseFormProcessing->set_caption('exterior', nl_translate("Exterior"));

	$baseFormProcessing->set_caption('patron_t', nl_translate("Patron"));
	$baseFormProcessing->set_caption('template_t', nl_translate("Template"));

	$baseFormProcessing->set_caption('description', nl_translate("Description"));
	$baseFormProcessing->set_caption('admin_name', nl_translate("Name of the addresser of e-mails"));
	$baseFormProcessing->set_caption('admin_email', nl_translate("Address e-mail of the addresser of e-mails"));
	$baseFormProcessing->set_caption('subject', nl_translate("Subject"));
	$baseFormProcessing->set_caption('body', nl_translate("Body"));
	$baseFormProcessing->set_caption('welcome', nl_translate("Message of welcome (after confirmation of inscription)"));
	$baseFormProcessing->set_caption('quit', nl_translate("Message of unsubscription"));
	$baseFormProcessing->set_caption('unsubscription', nl_translate("Unsubscription confirmation"));
	$baseFormProcessing->set_caption('subscription', nl_translate("Confirmation message of inscription"));
	$baseFormProcessing->set_caption('subscription_validation_period', nl_translate("Subcription validation period"));
	$baseFormProcessing->set_caption('disabled', nl_translate("Disable the newsletter"));
	$baseFormProcessing->set_caption('subscription_validation', nl_translate("Ask for a confirmation of inscription the unregistered users (no Ovidentia accounts)"));
	$baseFormProcessing->set_caption('unsubscription_validation', nl_translate("Ask for a confirmation of unsubscription the unregistered users (no Ovidentia accounts)"));
	$baseFormProcessing->set_caption('subscription_moderation', nl_translate("Subscription moderation"));
	$baseFormProcessing->set_caption('submit', nl_translate("Update"));
	$baseFormProcessing->set_caption('title', nl_translate("Parameters of the newsletter"));
	$baseFormProcessing->set_caption('action', nl_translate("edit"));
	$baseFormProcessing->set_caption('Yes', nl_translate("Yes"));
	$baseFormProcessing->set_caption('No', nl_translate("No"));
	$baseFormProcessing->set_caption('edit_lh_url', nl_url().'users&idx=editlh&id='.
		((isset($_GET['id'])) ? $_GET['id'] : $_POST['id']) );
	$baseFormProcessing->set_caption('edit_lf_url', nl_url().'users&idx=editlf&id='.
		((isset($_GET['id'])) ? $_GET['id'] : $_POST['id']) );

	$baseFormProcessing->set_error('name', nl_translate("The field name must not be empty"));
	$baseFormProcessing->set_error('subscription_subject', nl_translate("The field Subscription subject must no be empty"));
	$baseFormProcessing->set_error('subscription_body', nl_translate("The field Subscription body must no be empty"));
	$baseFormProcessing->set_error('welcome_subject', nl_translate("The field Welcome subject must no be empty"));
	$baseFormProcessing->set_error('welcome_body', nl_translate("The field Welcome body must no be empty"));
	$baseFormProcessing->set_error('quit_subject', nl_translate("The field Quit subject must no be empty"));
	$baseFormProcessing->set_error('quit_body', nl_translate("The field Quit body must no be empty"));
	$baseFormProcessing->set_error('unsubscription_subject', nl_translate("The field Unsubscription subjec must no be empty"));
	$baseFormProcessing->set_error('unsubscription_body', nl_translate("The field Unsubscription body must no be empty"));
	//$baseFormProcessing->set_error('subscription_validation_period', nl_translate("The field Subcription validation period must no be empty"));

	$baseFormProcessing->implode_errors(',');

	$newsletterInfo = array('id' => (isset($_GET['id']) ? $_GET['id'] : $_POST['id']));
	$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);

	$action = 'edit';

	if(isset($_GET['id']))
	{
		$newsletterInfo = $tableWrapper->load($newsletterInfo, STAR_ATTRIBUT, STAR_ATTRIBUT, 0, 1);
	}
	else if(isset($_POST['id']))
	{
		$newsletterInfo['name'] = 'dummy';
		$newsletterInfo = $tableWrapper->load($newsletterInfo, 1, 1, 0, 1);

		if(false !== $newsletterInfo)
		{
			$name = $newsletterInfo['name'];

			$newsletterInfo = array('id' => $_POST['id'],
				'name' => $name,
				'description' => nl_stripSlashes($_POST['description']),
				'admin_name' => nl_stripSlashes($_POST['admin_name']),
				'admin_email' => nl_stripSlashes($_POST['admin_email']),
				'img_insertion' => nl_stripSlashes($_POST['img_insertion']),
				'template' => nl_stripSlashes($_POST['template']),
				'subscription_subject' => nl_stripSlashes($_POST['subscription_subject']),
				'subscription_body' => nl_stripSlashes($_POST['subscription_body']),
				'welcome_subject' => nl_stripSlashes($_POST['welcome_subject']),
				'welcome_body' => nl_stripSlashes($_POST['welcome_body']),
				'quit_subject' => nl_stripSlashes($_POST['quit_subject']),
				'quit_body' => nl_stripSlashes($_POST['quit_body']),
				'unsubscription_subject' => nl_stripSlashes($_POST['unsubscription_subject']),
				'unsubscription_body' => nl_stripSlashes($_POST['unsubscription_body']),
				'subscription_validation_period' => /*$_POST['subscription_validation_period']*/0,
				'subscription_validation' => $_POST['subscription_validation'],
				'unsubscription_validation' => $_POST['unsubscription_validation'],
				'disabled' => $_POST['disabled']);
		}
	}

	if(false !== $newsletterInfo)
	{
		while(list($key, $val) = each($newsletterInfo))
		{
			$baseFormProcessing->set_data($key, $val);
		}

		$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);
		$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

		global $babBody;

		//$baseFormProcessing->get_caption('action', $action);
		$baseFormProcessing->get_caption('title', $babBody->title);

		addDefaultMenu();

		$babBody->addItemMenu($action,
			nl_translate($action), nl_url().'users&idx='.$action);

		$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'nlManagerEdit'));
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("ERROR : Cannot Edit a newsletter");
	}
}


/*
	Manager function:
		Qui permet de definir qui peut crire et qui peut s'abonner
*/
function setGroup($tableName, $title)
{
	global $babBody;

	$babBody->title = $title;

	$macl = new macl('addon/newsletter'.'/users', "defaultMenu", $_GET['id'], 'aclview');
	$macl->addtable($tableName, $title);

	if(NL_WRITERS_GROUP == $tableName)
	{
		$macl->filter(ENABLE_GROUP, ENABLE_GROUP, DISABLE_GROUP, ENABLE_GROUP, DISABLE_GROUP);
	}

	$macl->babecho();

	addDefaultMenu();
	$babBody->addItemMenu($_GET['idx'], nl_translate("Define right"), nl_url().'users');
}


/*
	Manager function:
*/
function ImportExportUsers()
{
	global $babBody;

	$baseFormProcessing = new BaseFormProcessing();
	$baseFormProcessing->set_caption('import', nl_translate("Import from a csv file"));
	$baseFormProcessing->set_caption('explanation', nl_translate("Import: the first line of the CSV file must contain the names of the fields"));
	$baseFormProcessing->set_caption('export', nl_translate("Export to a csv file"));
	$baseFormProcessing->set_caption('submit', nl_translate("Export"));
	$baseFormProcessing->set_caption('first_name', nl_translate("First Name"));
	$baseFormProcessing->set_caption('last_name', nl_translate("Last Name"));
	$baseFormProcessing->set_caption('email', nl_translate("E-mail Address"));
	$baseFormProcessing->set_caption('separator', nl_translate("Separator"));
	$baseFormProcessing->set_caption('other', /*nl_translate("Other")*/"Other");
	$baseFormProcessing->set_caption('comma', nl_translate("Comma"));
	$baseFormProcessing->set_caption('tab', nl_translate("Tab"));
	$baseFormProcessing->set_caption('invalid file', nl_translate("The file that you have entered is invalid"));
	$baseFormProcessing->set_caption('invalid separator',  nl_translate("The separator that you have entered is invalid"));

	$baseFormProcessing->set_data('topicID', (isset($_GET['id']) ? $_GET['id'] : $_POST['id']) );

	$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

	$babBody->title = nl_translate(" Import/Export some subscribers");

	addDefaultMenu();

	$babBody->addItemMenu('ImportExportUsers', $babBody->title, nl_url().'users');

	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'ImportExportUsers'));
}


// ----------------------------------------------------------------------- //
// Traitement
// ----------------------------------------------------------------------- //

/*
	Manager function:
		Le manager  diter un newsletter, il veut la sauvegarder
*/
function processEditNewsletter()
{
	if(isSet($_POST['id']) && isValidNewsletter())
	{
		$attributs = array(
			'id' => $_POST['id'],
			'description' => nl_escapeString($_POST['description']),
			'admin_name' => ('' != $_POST['admin_name']) ? nl_escapeString($_POST['admin_name']) :
				nl_escapeString($GLOBALS['babAdminName']),
			'admin_email' => ('' != $_POST['admin_email']) ? nl_escapeString($_POST['admin_email']) :
				nl_escapeString($GLOBALS['babAdminEmail']),
			'img_insertion' => nl_escapeString($_POST['img_insertion']),
			'template' => nl_escapeString($_POST['template']),
			'patron' => nl_escapeString($_POST['patron']),
//			'letter_header' => (true == isSet($_POST['letter_header'])) ? $_POST['letter_header'] : '',
//			'letter_footer' => (true == isSet($_POST['letter_footer'])) ? $_POST['letter_footer'] : '',
			'subscription_subject' => nl_escapeString($_POST['subscription_subject']),
			'subscription_body' => nl_escapeString($_POST['subscription_body']),
			'welcome_subject' => nl_escapeString($_POST['welcome_subject']),
			'welcome_body' => nl_escapeString($_POST['welcome_body']),
			'quit_subject' => nl_escapeString($_POST['quit_subject']),
			'quit_body' => nl_escapeString($_POST['quit_body']),
			'unsubscription_subject' => nl_escapeString($_POST['unsubscription_subject']),
			'unsubscription_body' => nl_escapeString($_POST['unsubscription_body']),
			'subscription_validation_period' => /*$_POST['subscription_validation_period']*/0,
			'disabled' => ('Yes' == $_POST['disabled']) ? 1 : 0,
			'subscription_validation' => ('Yes' == $_POST['subscription_validation']) ? SUBSCRIPTION_NEEDED : SUBSCRIPTION_NOT_NEEDED,
			'unsubscription_validation' => ('Yes' == $_POST['unsubscription_validation']) ? UNSUBSCRIPTION_NEEDED : UNSUBSCRIPTION_NOT_NEEDED
			);

		$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);

		if(false == $tableWrapper->update($attributs))
		{
			$GLOBALS['babBody']->msgerror = nl_translate("Error while updating");
			return false;
		}

		return true;
	}
}

/*
	Manager function:
		Fonction de validation de formulaire
*/
function isValidNewsletter()
{
	$newsletterInfo = array('description', 'admin_name', 'admin_email',
		'subscription_subject', 'subscription_body', 'welcome_subject',
		'welcome_body', 'quit_subject', 'quit_body', 'unsubscription_subject',
		'unsubscription_body');

	while(list($key, $val) = each($newsletterInfo))
	{
		if(!isset($_POST[$val]) || $_POST[$val] == '' || 0 == strlen($_POST[$val]))
		{
			$val = str_replace('_', ' ', $val);
			$GLOBALS['babBody']->msgerror = nl_translate("The field ") . $val . nl_translate(" is not valid");
			return false;
		}
	}
/*
	if(!isset($_POST['subscription_validation_period']) || !is_numeric($_POST['subscription_validation_period'])
		|| 0 > (int)$_POST['subscription_validation_period'])
	{
		$GLOBALS['babBody']->msgerror = nl_translate("The field subscription validation period is not valid");
		return false;
	}
*/
	return true;
}


/*
	Manager function:
		Le manager  diter un newsletter, il veut la sauvegarder
*/
function processImportExportUsers()
{
	if("Export" == $_POST['doWhat'])
	{
		exportUsers();
		return true;
	}
	else if("Import" == $_POST['doWhat'])
	{
		if('' != $_POST['separatorSelectCtrl'] && strlen($_POST['separatorSelectCtrl']) > 0)
		{
			$baseFormProcessing = new BaseFormProcessing();
			$baseFormProcessing->set_caption('import', nl_translate("Import from a csv file"));
			$baseFormProcessing->set_caption('first_name', nl_translate("First Name"));
			$baseFormProcessing->set_caption('last_name', nl_translate("Last Name"));
			$baseFormProcessing->set_caption('email', nl_translate("E-mail Address"));
			$baseFormProcessing->set_caption('other', nl_translate("Other"));
			$baseFormProcessing->set_caption('comma', nl_translate("Comma"));
			$baseFormProcessing->set_caption('tab', nl_translate("Tab"));
			$baseFormProcessing->set_caption('submit', nl_translate("Submit"));
			$baseFormProcessing->set_caption('title', nl_translate("Those fields must be filled"));
			$baseFormProcessing->set_caption('invalid file', nl_translate("This field must be filled"));

			$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

			$firstLine = '';
			if(true == copyRemoteFile2Dummy($firstLine))
			{
				$firstLine = trim($firstLine);

				$baseFormProcessing->set_data('separator', get_CSV_Separator($_POST['separatorSelectCtrl']));
				$baseFormProcessing->set_data('selectValues', $firstLine);
				$baseFormProcessing->set_data('topicID', $_POST['id']);

				global $babBody;

				$babBody->title = nl_translate("Import some subscribers");
				addDefaultMenu();
				$babBody->addItemMenu('ImportUsers', $babBody->title, nl_url().'users');

				$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'ImportUsers'));
				return true;
			}
		}
		else
		{
			$GLOBALS['babBody']->msgerror = nl_translate("The specified separator is not invalid");
		}
	}
	return false;
}

/*
	Manager function:
*/
function copyRemoteFile2Dummy(& $template)
{
	$error = (int)$_FILES['CSVFile']['error'];

	if(0 == $error)
	{
		$uploaded_filename = $_FILES['CSVFile']['tmp_name'];
		$local_filename = nl_getUploadPath().'dummy.txt';

		if(false == move_uploaded_file($uploaded_filename, $local_filename))
		{
				$GLOBALS['babBody']->msgerror = nl_translate("The uploaded file cannot be moved to the specified directory");
				return false;
		}
		else
		{
			$handle = @fopen($local_filename, "r");
			if(false != $handle)
			{
				// get the first line
				$template = @fgets($handle, 4096);
				@fclose($handle);
				return true;
			}
		}
	}
	else
	{
		switch($error)
		{
			//case /*UPLOAD_ERR_OK*/ 0:
				//$GLOBALS['babBody']->msgerror = nl_translate("There is no error, the file uploaded with success.";
			//	break;

			case /*UPLOAD_ERR_INI_SIZE*/ 1:
				$GLOBALS['babBody']->msgerror = nl_translate("The uploaded file exceeds the upload_max_filesize directive in php.ini.");
				return false;

			case /*PLOAD_ERR_FORM_SIZE*/ 2:
				$GLOBALS['babBody']->msgerror = nl_translate("The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.");
				return false;

			case /*UPLOAD_ERR_PARTIAL*/ 3:
				$GLOBALS['babBody']->msgerror = nl_translate("The uploaded file was only partially uploaded.");
				return false;

			case /*UPLOAD_ERR_NO_FILE*/ 4:
				$GLOBALS['babBody']->msgerror = nl_translate("No file was uploaded.");
				return false;
		}
	}
}


/*
	Manager function:
*/
function exportUsers()
{
	$separator = get_CSV_Separator($_POST['separatorSelectCtrl']);

	$output = getExportUsersList($separator);

	header("Content-Disposition: attachment; filename=\"" . 'users' . ".csv\""."\n");
	header("Content-Type: csv/plain"."\n");
	header("Content-Length: ". strlen($output) ."\n");
	header("Content-transfert-encoding: binary"."\n");
	print $output;
	die;

}


/*
	Manager function:
*/
function get_CSV_Separator($userChoice)
{
	switch($userChoice)
	{
		case 'Tab':
			return "\t";

		case 'Other':
			return $_POST['choosenSeparator'];

		case 'Comma':
		default:
			return ',';
	}
}

/*
	Manager function:
*/
function getExportUsersList($separator)
{
	$query =
		'SELECT DISTINCT ' .
			'id_ov_user, ' .
			'first_name, ' .
			'last_name, ' .
			'email ' .
		'FROM ' .
			NL_SUBSCRIBERS . ' ' .
		'WHERE ' .
			'id_newsletter_topic = \'' . $_POST['id'] . '\' AND ' .
			'subscription = \'' . SUBSCRIPTION_CONFIRMED . '\'';

	$output = $_POST['first_name'] .
		$separator . $_POST['last_name'] .
		$separator . $_POST['email'] . "\r\n";

	$newsletter = new NewsletterInfo($query);

	/*
		$_POST['first_name'] peut etre == nl_translate('First Name') ou
			nl_translate('Last Name') ou nl_translate('E-mail Address')
	*/

	/* tableau de correspondance */
	$keys = array(nl_translate("First Name") => 'first_name' ,
		nl_translate("Last Name") => 'last_name',
		nl_translate("E-mail Address") => 'email');

	while(false != $newsletter->getNextRow(false))
	{
		if(0 != $newsletter->m_datas['id_ov_user'])
		{
			$name = explode(" ", bab_getUserName($newsletter->m_datas['id_ov_user']));
			if (isset($name[0])) {
				$newsletter->m_datas['first_name'] = $name[0];
			} else {
				$newsletter->m_datas['first_name'] = "";
			}
			if (isset($name[1])) {
				$newsletter->m_datas['last_name'] = $name[1];
			} else {
				$newsletter->m_datas['last_name'] = "";
			}
			$newsletter->m_datas['email'] = bab_getUserEmail($newsletter->m_datas['id_ov_user']);
		}
		$output .= $newsletter->m_datas[$keys[$_POST['first_name']]] . $separator;
		$output .= $newsletter->m_datas[$keys[$_POST['last_name']]] . $separator;
		$output .= $newsletter->m_datas[$keys[$_POST['email']]] . "\r\n";
	}
	return $output;
}

/*
	Manager function:
*/
function processImportUsers()
{
	$filename = nl_getUploadPath().'dummy.txt';
	$handle = @fopen($filename, "r+");
	$reg = "/^([A-Za-z0-9_.-])+\@([A-Za-z0-9_.-])+\.([A-Za-z]{2,4})$/";
	if(false != $handle)
	{
		//read the first line
		$data = fgetcsv($handle, filesize($filename), $_POST['separator']);

		if(false != $data)
		{
			$firstNamePos = array_search($_POST['first_name'], $data, true);
			$lastNamePos = array_search($_POST['last_name'], $data);
			$emailPos = array_search($_POST['email'], $data);

			if(/*false !== $firstNamePos && false !== $lastNamePos &&*/ false !== $emailPos)
			{
				$table = new TableWrapper(NL_SUBSCRIBERS);
				while(($data = @fgetcsv($handle, filesize($filename), $_POST['separator'])))
				{

					if (isset($data[$emailPos])) {
						if(strlen(trim($data[$emailPos])) > 0)
						{
							if(preg_match($reg, trim($data[$emailPos]))){
								$attributsList = array(
									'id_ov_user' => 0,
									'first_name' => ((false !== $firstNamePos) ? nl_escapeString(trim($data[$firstNamePos])) : ''),
									'last_name' => ((false !== $lastNamePos) ? nl_escapeString(trim($data[$lastNamePos])) : ''),
									'id_newsletter_topic' => $_POST['id'],
									'email' => nl_escapeString(trim($data[$emailPos])),
									'subscription_date' => 'now()',
									'subscription' => SUBSCRIPTION_CONFIRMED);

								if(false === $table->load($attributsList, 3, 2, 3, 2))
								{
									$table->save($attributsList, false, true);
								}
							}
						}
					}
				}
			}
		}
		@fclose($handle);

		//the is now empty
		$handle = @fopen($filename, "w+");
		@fclose($handle);
	}
	else
	{
	}
}


/*
	Manager function:
*/
function editLetters($what)
{
	global $babBody;

	$fieldName = '';
	if( $what == 'editlh' )
	{
		$fieldName = 'letter_header';
	}
	else
	{
		$fieldName = 'letter_footer';
	}

	$attributs = array('id' => bab_rp('id'), $fieldName => '');

	$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);

	$attributs = $tableWrapper->load($attributs, 0, 2, 0, 1);

	$baseFormProcessing = new BaseFormProcessing();

	$baseFormProcessing->set_caption('updatetxt', nl_translate("Update"));

	$baseFormProcessing->id = $_GET['id'];
	$baseFormProcessing->set_data('what', $what);

	// use the WYSIWYG Editor
	require_once $GLOBALS['babInstallPath']."utilit/editorincl.php";
	$editor = new bab_contentEditor('content');
	$editor->setContent($attributs[$fieldName]);
	$editor->setFormat('email');
	$baseFormProcessing->set_data('content', $editor->getEditor());
	$baseFormProcessing->set_data('id', bab_rp('id'));

	/*$babBody->babPopup(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', "editletter"));*/
	die(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', "editletter"));
}


/*
	Manager function:
*/
function processEditLetter($action)
{
	$fieldName = '';
	if( $action == 'editlh' )
	{
		$fieldName = 'letter_header';
	}
	else
	{
		$fieldName = 'letter_footer';
	}

	$attributs = array('id' => $_POST['id'], $fieldName => nl_escapeString($_POST['content']));

	$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);
	$tableWrapper->update($attributs, false);

	//Close the pop up window
	{
		$baseFormProcessing = new BaseFormProcessing();
		global $babBody;
		$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'manager.html', 'close_popup'));
	}
}

function deleteSubscriber()
{
	$id_list = '';

	if(isset($_POST['subscriber']))
	{
		foreach($_POST['subscriber'] as $key => $value)
		{

//echo 'key > ' . $key . ' value => ' . $value . '<br />';

			$id_list .=  ', \'' . $value . '\'';
		}

		$id_list = substr($id_list, strlen(', '));

		// echo '$id_list => ' . $id_list . '<br />';

		$db = &$GLOBALS['babDB'];
		$query = 'DELETE FROM ' . NL_SUBSCRIBERS . ' WHERE id IN (' . $id_list . ')';
		$result	= $db->db_query($query);
	}
}


/*
SELECT *
FROM `nl_subscribers`
WHERE subscription_date < DATE_SUB( NOW( ) , INTERVAL 2
DAY )
LIMIT 0 , 30

SELECT DATE_SUB( NOW( ) , INTERVAL 5 DAY )
*/
?>