<?php

	require_once(dirname(__FILE__) . '/nlDataBase.php'); 
	require_once(dirname(__FILE__) . '/nlincl.php');
	require_once(dirname(__FILE__) . '/defines.php');
	require_once($GLOBALS['babInstallPath'].'utilit/mailincl.php');
	require_once($GLOBALS['babInstallPath'].'utilit/path.class.php');


	class TableWrapper
	{
		var $m_db;
		var $m_TableName;

		function TableWrapper($tableName)
		{
			$this->m_db = new nlDB();
			$this->m_TableName = $tableName;
		}

		function setTableName($tableName)
		{
			$this->m_TableName = $tableName;
		}

		function getTableName()
		{
			return $this->m_TableName;
		}

		//Zero based
		function buildSelect(& $attribut, $offset = ALL_ATTRIBUTS, $length = ALL_ATTRIBUTS)
		{
			if(STAR_ATTRIBUT == $offset)
			{
				return '*';
			}
			else if(ALL_ATTRIBUTS == $offset)
			{
				return implode(",", array_keys($attribut));
			}
			else
			{
				$arrayKeys = array_keys($attribut);
				$size = count($arrayKeys);
				$start = ( $offset > 0 && $offset < $size ) ? $offset : 0;
				if(ALL_ATTRIBUTS == $length)
				{
					$end = $size - $start;
				}
				else
				{
					$remain = $size - $start;
					$end = ( $length > 0 && $length < $remain ) ? $length : $remain;
				}
				$arrayKeys = array_slice($arrayKeys, $start, $end);
				return implode(",", $arrayKeys);
			}
		}

		//zero based
		function buildWhereClause(& $attribut, $offset = ALL_ATTRIBUTS, $length = ALL_ATTRIBUTS)
		{
			if(NEWSLETTER_NONE == $offset)
			{
				return '';
			}

			$size = 0;
			$start = 0;
			$end   = 0;
			
			if(ALL_ATTRIBUTS == $offset)
			{
				$end = count($attribut);
			}
			else
			{
				$size = count($attribut);

				$start = ( $offset > 0 && $offset < $size ) ? $offset : 0;

				if(ALL_ATTRIBUTS == $length)
				{
					$end = $size - $start;
				}
				else
				{
					$remain = $size - $start;
					$end = ( $length > 0 && $length < $remain ) ? $length : $remain;
				}
			}

			$reducedArray = array_slice($attribut, $start, $end);
			$size = count($reducedArray);

			$idx = 0;
			$whereClause = $key = $value = '';

			while($idx < $size) 
			{
				list($key, $value) = each($reducedArray);
				$whereClause .= ' AND ' . $key . '=\'' . $value . '\'';
				++$idx;
			}

			reset($attribut);
			return ' WHERE ' . substr($whereClause, strlen(' AND '));
		}

		function load(& $attribut, $selectOffset = ALL_ATTRIBUTS, $selectLength = ALL_ATTRIBUTS,
			$whereClauseOffset = ALL_ATTRIBUTS, $whereClauseLength = ALL_ATTRIBUTS)
		{
			$attributNameList	= $this->buildSelect($attribut, $selectOffset, $selectLength);
			$whereClause		= $this->buildWhereClause($attribut, $whereClauseOffset, $whereClauseLength);

			$request = 'SELECT ' . $attributNameList . ' FROM ' . $this->m_TableName . $whereClause; 

			$result = $this->m_db->db_query($request);
			return $this->m_db->db_fetch_assoc($result); 
		}

		function save(& $attributsList, $skipFirst = true, $bDateInAttributsList = false)
		{
			reset($attributsList);
			
			if(true === $skipFirst)
			{
				//skip the first element
				next($attributsList);
			}
				
			$item 	= '';
			$insert = '';
			$values = '';

			while($item = each($attributsList))
			{
				$insert .= ', ' . $item['key'];
				$values .= ', ' . '\'' . $item['value'] . '\'';
			}
				
			if(true === $bDateInAttributsList)
			{
				$values = str_replace("'now()'", "now()", $values);
			}
			
			$requete = 'INSERT INTO ' . $this->m_TableName . '(  '. substr($insert, strlen(', ')) . ') ' . 
				'VALUES ( ' . substr($values, strlen(', ')) . ')';

			return $this->m_db->db_query($requete);
		}

		function update(& $attributsList, $bDateInAttributsList = false)
		{
			//skip the first element
			reset($attributsList);
			next($attributsList);
				
			$requete = '';
			$item = '';
			while($item = each($attributsList))
			{
				$requete .= ', ' . $item['key'] . '=\'' . $item['value'] . '\'';
			}

			if(true == $bDateInAttributsList)
			{
				$requete = str_replace("'now()'", "now()", substr($requete, strlen(', ')));
			}
			else
			{
				$requete = substr($requete, strlen(', '));
			}
			
			$requete = 'UPDATE ' . $this->m_TableName . ' SET ' . $requete . ' WHERE id = \'' 
				. $attributsList['id'] . '\'';

			return $this->m_db->db_query($requete);
		}

		function delete(& $attribut, $whereClauseOffset = ALL_ATTRIBUTS, $whereClauseLength = ALL_ATTRIBUTS)
		{
			$whereClause = $this->buildWhereClause($attribut, $whereClauseOffset, $whereClauseLength);

			$request = 'DELETE FROM ' . $this->m_TableName . $whereClause; 
			
			return $this->m_db->db_query($request);
		}
	}

	class BaseFormProcessing
	{
		var $m_datas;
		var $m_captions;

		var $m_errors;

		var $m_implodedErrorKeys;
		var $m_implodedErrorValues;

		var $m_anchor;
		var $m_anchorItem;

		function BaseFormProcessing()
		{
			$this->m_datas					= array();
			$this->m_captions				= array();
			$this->m_errors					= array();
			$this->m_anchor					= array();
			$this->m_anchorItem				= array();
			$this->m_implodedErrorKeys		= '';
			$this->m_implodedErrorValues	= '';
		}

		function get_data($property_name, &$property_value)
		{
			if(isset($this->m_datas[$property_name]))
			{
				$property_value = $this->m_datas[$property_name];
				return true;
			}
			return false;
		}

		function set_data($property_name, $property_value)
		{
			$this->m_datas[$property_name] = $property_value;
			return true;
		}

		function get_caption($property_name, &$property_value)
		{
			if(isset($this->m_captions[$property_name]))
			{
				$property_value = $this->m_captions[$property_name];
				return true;
			}
			return false;
		}

		function set_caption($property_name, $property_value)
		{
			$this->m_captions[$property_name] = $property_value;
			return true;
		}

		function set_error($property_name, $property_value)
		{
			$this->m_errors[$property_name] = $property_value;
			return true;
		}

		function implode_errors($separator, $javascript=false)
		{
			$this->m_implodedErrorKeys = implode($separator, array_keys($this->m_errors));
			$this->m_implodedErrorValues = implode($separator, array_values($this->m_errors));
			if (!$javascript) {
				$this->m_implodedErrorValues = raw_2_html($this->m_implodedErrorValues);
			}
		}

		function raw_2_html($type)
		{
			switch($type)
			{
				case RAW_2_HTML_DATA:
					array_walk($this->m_datas, array('raw2HtmlClass', 'transform'));
					break;

				case RAW_2_HTML_CAPTION:
					array_walk($this->m_captions, array('raw2HtmlClass', 'transform'));
					break;
			}
		}

		function set_anchor($href, $imgSrc, $title)
		{
			$item = array('href' => $href,
				'title' => nl_translate($title),
				'imgSrc' => $imgSrc);

			array_push($this->m_anchor, $item);
		}
	}


	class SubscriberList extends BaseFormProcessing
	{
		var $m_change_background;
		var $m_db;
		var $m_result;

		var $m_subscriber;


		/*
			permet de retrouver le nom d'une colonne en fonction
			de son No 
		*/
		var $attribut_translation;

		/*
			permet de retrouver le caption d'une colonne  afficher
			en fonction du nom de la colonne
		*/
		var $column_caption;

		var $m_pagination;

		function SubscriberList($query)
		{
			parent::BaseFormProcessing();
			$this->m_db = new nlDB();

			$this->m_change_background = 0;

			$this->m_datas['column_data']				= array();
			$this->m_captions['selected_column_text']	= '';
			$this->m_datas['is_column_selected']		= 0;
			$this->m_datas['selected_column_url']		= '';
			$this->m_datas['is_column_selected']		= 0;
			$this->m_datas['number_of_column']			= 0;
			$this->m_datas['selected_colum']			= 0;

			$this->attribut_translation = array(FIRSTNAME => 'first_name',
				LASTNAME => 'last_name', 
				EMAIL => 'email',
				SUBSCRITION_DATE => 'subscription_date', 
				SUBSCRIPTION => 'subscription');

			$this->column_caption = array('first_name' => nl_translate("First Name"),
				'last_name' => nl_translate("Last Name"), 
				'email' => nl_translate("Email"),
				'subscription_date' => nl_translate("Subscription date"), 
				'subscription' => nl_translate("Status"),
				);

			$this->m_pagination = new Pagination();

			$page = (int) isset($_GET['page']) ? $_GET['page'] : $_POST['page'];
			$filter = nl_escapeString(isset($_GET['filter']) ? $_GET['filter'] : $_POST['filter']);
			$attribut = (int) isset($_GET['attribut']) ? $_GET['attribut'] : $_POST['attribut'];
			$order = (int) isset($_GET['order']) ? $_GET['order'] : $_POST['order'];
			$research_type = (int) isset($_GET['research_type']) ? $_GET['research_type'] : $_POST['research_type'];
			$topic_id = (int) isset($_GET['topic_id']) ? $_GET['topic_id'] : $_POST['topic_id'];

			$first_name = nl_escapeString( (isset($_POST['first_name']) ? $_POST['first_name'] : '') );
			$last_name = nl_escapeString(isset($_POST['last_name']) ? $_POST['last_name'] : '');
			$email = nl_escapeString(isset($_POST['email']) ? $_POST['email'] : '');
			$begin_date = nl_escapeString(isset($_POST['begin_date']) ? $_POST['begin_date'] : '');
			$begin_date_sign = nl_escapeString(isset($_POST['begin_date_sign']) ? $_POST['begin_date_sign'] : '');
			$dates_separator = nl_escapeString(isset($_POST['form_dates_separator']) ? $_POST['form_dates_separator'] : '');
			$end_date = nl_escapeString(isset($_POST['end_date']) ? $_POST['end_date'] : '');
			$end_date_sign = nl_escapeString(isset($_POST['end_date_sign']) ? $_POST['end_date_sign'] : '');
			$subscription = (int) isset($_POST['subscription']) ? $_POST['subscription'] : 0;

			$nb_row_per_page = (int) isset($_POST['nb_row_per_page']) ? $_POST['nb_row_per_page'] : 10;

			$this->set_data('page', $page);
			$this->set_data('filter', $filter);
			$this->set_data('attribut', $attribut);
			$this->set_data('order', $order);
			$this->set_data('research_type', $research_type);
			$this->set_data('topic_id', $topic_id);

			$this->set_data('first_name', $first_name);
			$this->set_data('last_name', $last_name);
			$this->set_data('email', $email);
			$this->set_data('begin_date', $begin_date);
			$this->set_data('begin_date_sign', $begin_date_sign);
			$this->set_data('dates_separator', $dates_separator);
			$this->set_data('end_date', $end_date);
			$this->set_data('end_date_sign',$end_date_sign);
			$this->set_data('subscription', $subscription);

			
			$this->m_pagination->set_data('current_page', $page);
			$this->m_pagination->set_data('current_filter', $filter);
			$this->m_pagination->set_data('all_filter', true);
			$this->m_pagination->set_data('attribut_translation', $this->attribut_translation);
			$this->m_pagination->set_data('attribut', $attribut);

			$this->m_pagination->set_data('nb_link', 5);
			$this->m_pagination->set_data('template_page_path', nl_relativePath().'manager.html');
			$this->m_pagination->set_data('template_page_name', 'pagination');
			$this->m_pagination->set_data('template_filter_path', nl_relativePath().'manager.html');
			$this->m_pagination->set_data('template_filter_name', 'alphapage');
			$this->m_pagination->set_data('table_name', NL_SUBSCRIBERS);

			//Param1 == No page
			//Param2 == Lettre (filter)
			//Param3 == No de colonne (attribut)
			$page_url = 'javascript:goto_page(%d,\'%s\',%d);';
			$this->m_pagination->set_data('page_url', $page_url); /* research_type doit tre ==  celui en cours */

			/* 
				Quand on clique sur une lettre
				research_type doit tre == NORMAL_RESEARCH 
				il sera chang ds le JavaScript
			*/
			$filter_url = 'javascript:goto_page_filter(%d,\'%s\',%d);';
			$this->m_pagination->set_data('filter_url', $filter_url); 

			/* 
				Quand on clique sur une colonne
				Chang ds le JavaScript
				research_type doit tre == NORMAL_RESEARCH
				((ORDER_ASC == order) ? ORDER_DESC : ORDER_ASC)
			*/
			$attribut_url = 'javascript:goto_page_attribut(%d,\'%s\',%d);';

			$this->m_datas['selected_colum'] = $attribut;

			/* Contruction des url pour les colonnes */
			$column_data = array();
			foreach($this->attribut_translation as $key => $value)
			{
				$column_data[$value] = array('caption' => $this->column_caption[$value], 
					'url' => sprintf($attribut_url, 1, $filter, $key));
			}

			$this->m_datas['column_data'] = $column_data;
			$this->m_datas['number_of_column'] = count($column_data);

			$query = 'SELECT id, id_ov_user, id_newsletter_topic, first_name, last_name, email, subscription_date, subscription FROM ' . NL_SUBSCRIBERS;
			
			$where = '';

			if(NORMAL_RESEARCH == $research_type)
			{
				$where = $this->get_normal_research_where_clause($filter, $attribut, $order, $topic_id);
//echo $where . '<br />';
			}
			else if(ADVANCED_RESEARCH == $research_type)
			{
				$where = $this->get_advanced_research_where_clause($topic_id);
//echo $where . '<br />';
			}

//-------------------------------------------------
			if('All' == $nb_row_per_page)
			{
				$this->m_datas['nb_row_per_page'] = 'All';
				$query_count = 'SELECT COUNT(*) FROM ' . NL_SUBSCRIBERS . ' ' . $this->get_normal_research_where_clause($filter, $attribut, $order, $topic_id);
				$result = $this->m_db->db_query($query_count);
				$count = $this->m_db->db_fetch_assoc($result);

				$nb_row_per_page = 10;
				if(false != $count)
				{
					$nb_row_per_page = $count['COUNT(*)'];
				}

				$query .= $where . 'LIMIT 0, ' . $nb_row_per_page;
				//echo $query . '<br />';
			}
			else
			{
				$this->m_datas['nb_row_per_page'] = $nb_row_per_page;
				$query .= $where . 'LIMIT ' . (($page - 1) * $nb_row_per_page) . ', ' . $nb_row_per_page;
				//echo $query . '<br />';
			}
//-------------------------------------------------

			$this->m_pagination->set_data('nb_row_per_page', $nb_row_per_page);
			$this->m_result = $this->m_db->db_query($query);

			$this->m_datas['pagination'] = $this->m_pagination->get_multipage();
			$this->m_datas['status_line'] = $this->m_pagination->get_status_line();
			$this->m_datas['alphapage'] = $this->m_pagination->get_alphapage($topic_id);
			$this->m_datas['display'] = nl_translate("Display ");
			$this->m_datas['resultsperpage'] = nl_translate("results per pages");
			$this->m_datas['delete'] = nl_translate("Delete the checked subscribers");
			$this->m_datas['deletee'] = nl_translate("Delete the checked subscribers");
		}

		function get_next_column()
		{
			$current_item = each($this->m_datas['column_data']);

			if(false != $current_item)
			{
				/*
					La fonction each retourne un tableau associatif
					dont une des cles est 'value'
				*/
				$this->m_captions['selected_column_text'] = $current_item['value']['caption'];
				$this->m_datas['selected_column_url'] = $current_item['value']['url'];
				$this->m_datas['is_column_selected'] = 0;

				return true;
			}
			else
			{
				reset($this->m_datas['column_data']);
				return false;
			}
		}

		function get_next_subscriber()
		{
			$this->m_subscriber = $this->m_db->db_fetch_assoc($this->m_result);
			//Modification des valeurs des statuts d'inscription
			if ($this->m_subscriber['subscription'] == 1) {
				$this->m_subscriber['subscription'] = nl_translate("Subscription to confirm");
			}
			if ($this->m_subscriber['subscription'] == 2) {
				$this->m_subscriber['subscription'] = nl_translate("Subscription confirmed");
			}
			if ($this->m_subscriber['subscription'] == 3) {
				$this->m_subscriber['subscription'] = nl_translate("Unsubscription to confirm");
			}
			if ($this->m_subscriber['subscription'] == 4) {
				$this->m_subscriber['subscription'] = nl_translate("Unsubscription confirmed");
			}

			if(false != $this->m_subscriber)
			{
				$this->m_change_background = !$this->m_change_background;
				return true;
			}
			else
			{
				return false;
			}
		}

		function get_normal_research_where_clause($filter, $attribut, $order, $topic_id)
		{
			$where = '';
			if(NEWSLETTER_NONE != $attribut)
			{
				if('All' != $filter)
				{
					switch($attribut)
					{
						case FIRSTNAME:
						case LASTNAME:
						case EMAIL:
//echo 'Filter == [FIRSTNAME LASTNAME EMAIL] <br />';
							$where = ' WHERE ' . $this->attribut_translation[$attribut] . 
								' LIKE \'' . $filter . '%\' AND id_newsletter_topic = \'' . $topic_id . '\'';

							$query_count = 'SELECT SUM(' . $this->attribut_translation[$attribut] . ' LIKE \'' . $filter . 
								'%\') total_num_of_rows FROM ' . NL_SUBSCRIBERS . 
								' WHERE id_newsletter_topic = \'' . $topic_id . '\'';
							$result = $this->m_db->db_query($query_count);
							$nb_rows = $this->m_db->db_fetch_assoc($result);
							$this->m_pagination->set_data('total_num_of_rows', $nb_rows['total_num_of_rows']);

							break;

						//case SUBSCRITION_DATE:
						//	break;

						case SUBSCRIPTION:
//echo 'Filter == [SUBSCRIPTION] <br />';
							$where = ' WHERE id_newsletter_topic = \'' . $topic_id . '\'';

							$query_count = 'SELECT COUNT(*) total_num_of_rows FROM ' . NL_SUBSCRIBERS .
								' WHERE '  . $this->attribut_translation[$attribut] .
								' = \'' . $order . '\' AND id_newsletter_topic = \'' . $topic_id . '\'';

							$result = $this->m_db->db_query($query_count);
							$nb_rows = $this->m_db->db_fetch_assoc($result);
							$this->m_pagination->set_data('total_num_of_rows', $nb_rows['total_num_of_rows']);
						break;

						default:
//echo 'default Filter != ALL <br />';
							$where = ' WHERE id_newsletter_topic = \'' . $topic_id . '\'';

							$query_count = 'SELECT COUNT(*) total_num_of_rows FROM ' . NL_SUBSCRIBERS .
								' WHERE id_newsletter_topic = \'' . $topic_id . '\'';
							$result = $this->m_db->db_query($query_count);
							$nb_rows = $this->m_db->db_fetch_assoc($result);
							$this->m_pagination->set_data('total_num_of_rows', $nb_rows['total_num_of_rows']);
							break;
					}
				}
				else
				{
//echo 'Filter == ALL <br />';
					$where = ' WHERE id_newsletter_topic = \'' . $topic_id . '\'';

					$query_count = 'SELECT COUNT(*) total_num_of_rows FROM ' . NL_SUBSCRIBERS .
						' WHERE id_newsletter_topic = \'' . $topic_id . '\'';
					$result = $this->m_db->db_query($query_count);
					$nb_rows = $this->m_db->db_fetch_assoc($result);
					$this->m_pagination->set_data('total_num_of_rows', $nb_rows['total_num_of_rows']);
				}

				$where .=  ' ORDER BY ' . $this->attribut_translation[$attribut] . 
					((ORDER_ASC == $order) ? ' ASC ' : ' DESC ');
			}
			return $where;
		}
	
		function get_advanced_research_where_clause($topic_id)
		{
			$where = '';
			$query_count = '';
			
			$where_clause = array();

			if('' != $this->m_datas['first_name'])
			{
				$where_clause[] = $this->attribut_translation[FIRSTNAME] . ' LIKE \'' . $this->m_datas['first_name'] . '%\'';
			}

			if('' != $this->m_datas['last_name'])
			{
				$where_clause[] = $this->attribut_translation[LASTNAME] . ' LIKE \'' . $this->m_datas['last_name'] . '%\'';
			}

			if('' != $this->m_datas['email'])
			{
				$where_clause[] = $this->attribut_translation[EMAIL] . ' LIKE \'' . $this->m_datas['email'] . '%\'';
			}

			{
				$begin_date = '';
				$end_date = '';
				$separator = '';
				$subscription_date = $this->attribut_translation[SUBSCRITION_DATE];

				if('' != $this->m_datas['begin_date'])
				{
					$begin_date = $subscription_date . ' ' . $this->m_datas['begin_date_sign'] . ' \' ' . 
						$this->m_datas['begin_date'] . '\' ';
				}

				if('' != $this->m_datas['end_date'])
				{
					$end_date = $subscription_date . ' ' . $this->m_datas['end_date_sign'] . ' \' ' . 
							$this->m_datas['end_date'] . '\' ';
				}

				if('' != $begin_date && '' != $end_date)
				{
					$where_clause[] = '(' . $begin_date . $this->m_datas['dates_separator'] . ' ' . $end_date . ')';
				}
				else if('' != $begin_date || '' != $end_date)
				{
					$where_clause[] = '(' . $begin_date . ' ' . $end_date . ')';
				}
			}

			{
				$subscription = '';
				$subscription_value = array(SUBSCRIPTION_TO_CONFIRME, SUBSCRIPTION_CONFIRMED,
					UNSUBSCRIPTION_TO_CONFIRME, UNSUBSCRIPTION_CONFIRMED);

				foreach($subscription_value as $key => $value)
				{

//echo '==> ' . (int) $value & (int) $this->m_datas['subscription'] . '<br />';
//echo '==> ' . (int) $this->m_datas['subscription'] . '<br />';

//					if( ((int) $value & (int) $this->m_datas['subscription']) == (int) $value )
					{
						$subscription .= 'AND ' . $this->attribut_translation[SUBSCRIPTION] . '= \'' . $value . '\' ';
					}
				}
			

				if('' != $subscription)
				{
					$where_clause[] = substr($subscription, strlen('AND '));
//echo 'where_clause ==> ' . $where_clause . '<br />';
				}
			}



			if('' != $query_count)
			{
				$query_count .= 'total_num_of_rows FROM ' . NL_SUBSCRIBERS .
					' WHERE id_newsletter_topic = \'' . $topic_id . '\'';
				$result = $this->m_db->db_query($query_count);
				$nb_rows = $this->m_db->db_fetch_assoc($result);
				$this->m_pagination->set_data('total_num_of_rows', $nb_rows['total_num_of_rows']);
			}
			else
			{
				$this->m_pagination->set_data('total_num_of_rows', 0);
			}

			if(count($where_clause) > 0)
			{
//$str = ' WHERE ' . implode(' AND ', $where_clause) . ' AND id_newsletter_topic = \'' . $topic_id . '\' ';
//echo 'where_clause ==> ' . $str . '<br />';

				return (' WHERE ' . implode(' AND ', $where_clause)) . ' AND id_newsletter_topic = \'' . $topic_id . '\' ';
			}
			else
			{
				return /*' '*/ ' WHERE id_newsletter_topic = \'' . $topic_id . '\' ';
			}

//			$where .=  ' ORDER BY ' . $this->attribut_translation[$attribut] . 
//				((ORDER_ASC == $order) ? ' ASC ' : ' DESC ');
		}
	}


	class NewsletterInfo extends BaseFormProcessing
	{
		var $m_db;
		var $m_result;

		function NewsletterInfo($query)
		{
			parent::BaseFormProcessing();
			$this->m_db = new nlDB();

			$this->m_result = $this->m_db->db_query($query);
		}

		function getNextRow($to_html = true)
		{
			$this->m_datas = $this->m_db->db_fetch_assoc($this->m_result);

			if(false != $this->m_datas)
			{
				if($to_html)
				{
					$this->raw_2_html(RAW_2_HTML_DATA);
				}
				return true;
			}
			else
			{
				return false;
			}
		}

		function getNextAnchor()
		{
			$this->m_anchorItem = each($this->m_anchor);

			if(false != $this->m_datas && false != $this->m_anchorItem)
			{
				/*
					La fonction each retourne un tableau associatif
					dont une des cles est 'value'
				*/
				$this->m_anchorItem = $this->m_anchorItem['value'];
				return true;
			}
			else
			{
				reset($this->m_anchor);
				return false;
			}
		}
	}


	class WriterLetterInfo extends NewsletterInfo
	{
		var $m_nameAndDescription;

		function WriterLetterInfo($query)
		{
			parent::NewsletterInfo($query);

			if(false !== $this->m_result && $this->m_db->db_num_rows($this->m_result) > 0)
			{
				$attributsList = $this->m_db->db_fetch_assoc($this->m_result);

				$this->m_nameAndDescription['name'] = raw_2_html($attributsList['name']);
				$this->m_nameAndDescription['description'] = raw_2_html($attributsList['description']);
				
				$this->m_db->m_db->db_data_seek($this->m_result, 0);
			}
		}

		function getTitle()
		{
			if(isSet($this->m_nameAndDescription['name']))
			{
				return nl_translate($this->m_nameAndDescription['name']) .
					':' . nl_translate($this->m_nameAndDescription['description']);
			}
			else
			{
				return nl_translate("No letter for this newsletter");
			}
		}
	}


	class SendSubscriptionInfo
	{
		var $m_datas;

		function SendSubscriptionInfo(& $attributs)
		{
			$this->m_datas = & $attributs;
		}

		function send()
		{
			$mail = bab_mail();
			if( $mail === false )
			{
				return false;
			}

			$mail->mailTo($this->m_datas['email']);

			$mail->mailFrom($this->m_datas['admin_email'], $this->m_datas['admin_name']);
			$mail->mailSubject($this->m_datas['subject']);

			$message = $mail->mailTemplate(bab_printTemplate($this, nl_relativePath()."user.html", "EmailSubscription"));
			$mail->mailBody($message, "html");
			$messageNoHtml = strip_tags($message);
			$mail->mailAltBody($messageNoHtml); //message brut pour les lecteurs qui ne lisent pas le format HTML
			
			if(false == $mail->send())
			{
				return false;
			}

			return true;
		}
	}

	class SendLetter
	{
		var $m_datas;

		var $m_newsletterInfo;

		var $m_letter2Send;

		var $m_db;


		function SendLetter()
		{
		}

		function sendEmail()
		{
			$this->m_datas = array();

			$this->m_db = new nlDB;

			// Get newsletter info
			$this->loadNewsletterTopicInfo();

			// Compose the letter
			$this->composeLetter();

			//Create the query
			$query = 'SELECT id, id_ov_user, email, first_name' .
				' FROM ' . NL_SUBSCRIBERS .
				' WHERE id_newsletter_topic = ' . $_GET['nlID'] . 
					' AND subscription = \'' . SUBSCRIPTION_CONFIRMED . '\'';


			$this->sendEmailByA($query);
		}


		function makeUnsubscribeUrl(& $subscribers, $forSend = false)
		{
			if($forSend){
				buildSubscriptionURL($subscribers, UNSUBSCRIPTION_CONFIRMATION_URL_FOR_SEND, $subscribers['id'], $_GET['nlID']);
			}else{
				buildSubscriptionURL($subscribers, UNSUBSCRIPTION_CONFIRMATION_URL, $subscribers['id'], $_GET['nlID']);
			}
		}

		function loadNewsletterTopicInfo()
		{
			$this->m_newsletterInfo = array('id' => $_GET['nlID'], 
				'smtp_msg_sent_by_loop' => 0, 'send_method' => 0,
				'admin_email' => '', 'admin_name' => '');

			$tableWrapper = new TableWrapper(NL_NEWSLETTER_TOPIC);
			$this->m_newsletterInfo = $tableWrapper->load($this->m_newsletterInfo, 0, 5, 0, 1);
		}

		function composeLetter()
		{
			$query = 'SELECT letter.id as id_letter, nl.img_insertion as embeded, nl.template as template, nl.patron as patron, nl.letter_header, nl.letter_footer, letter.subject, letter.body' .
				' FROM ' . NL_NEWSLETTER_TOPIC . ' nl' .
				' LEFT JOIN ' . NL_LETTERS . ' letter ON ' . 'letter.id = \'' . $_GET['letterID'] . '\'' .
				' WHERE nl.id = ' . $_GET['nlID'];

			$result = $this->m_db->db_query($query);
			$this->m_letter2Send = $this->m_db->db_fetch_assoc($result);

 			$this->m_letter2Send['unsubcribe_txt']		= nl_translate("unsubscription");
			$this->m_letter2Send['confirmation_url']	= '';
			$this->m_letter2Send['confirmation_txt']	= '';
		}
 

		function sendEmailByA($query)
		{
			$email =  '';
			static $message;
			static $sizeMail;
			static $messageNoHtml;
			static $mailEmbeddedImage;

// 			$log = new logFile('SendEmail.txt');
// 			$log->write('sendEmailByA : START');
// 			$log->write("\r\n");
			
			$mail = bab_mail();
			if( $mail === false )
			{
// 				$log->write('sendEmailByA : NO bab_mail');
// 				$log->write("\r\n");
				return;
			}
			
			$this->m_datas = & $this->m_letter2Send;
			require_once $GLOBALS['babInstallPath']."utilit/editorincl.php";
			$editor = new bab_contentEditor('newsletter_body');
			$editor->setContent($this->m_datas['body']);
			$editor->setFormat('html');
			$this->m_datas['body'] = $editor->getHtml();
			
			$offset = $_GET['offset'];
			
			if( false != ($result = $this->m_db->db_query($query)) )
			{
				$offset += $this->m_db->db_num_rows($result);
				$mail->mailFrom($this->m_newsletterInfo['admin_email'], $this->m_newsletterInfo['admin_name']);
				$mail->mailSubject($this->m_letter2Send['subject']);

// 				$log->write('sendEmailByA : ' . $query);
// 				$log->write("\r\n");
				
				$numrow = $this->m_db->db_num_rows($result);
				$timelimit = 300;
				if($numrow >= 150){
					$timelimit = $numrow*2;
				}
				set_time_limit($timelimit);
				
				$subscribersemails = array(); /* utilis afin de ne pas envoyer de mails en doublons */
				$subscribers = array();
				while( false != ($subscribers = $this->m_db->db_fetch_assoc($result)) )
				{
// 					$startTime = microtime(true);
					if(0 != $subscribers['id_ov_user'])
					{
						$email = bab_getUserEmail($subscribers['id_ov_user']);
						// ignore if user disabled
						
						$infos = bab_getUserInfos($subscribers['id_ov_user']);
						if ($infos['disabled'])
						{
							continue;
						}
					}
					else
					{
						$email = $subscribers['email'];
					}

					if ($email && !in_array($email, $subscribersemails)) {
						$subscribersemails[] = $email;
					
						$this->makeUnsubscribeUrl($subscribers, true);
		
						$this->m_datas['unsubcribe_url'] = & $subscribers['unsubcribe_url'];
						
						$mail->mailTo($email);
						
						/*for template var*/
						$this->header = $this->m_datas["letter_header"];
						$this->body = $this->m_datas["body"];
						$this->footer = $this->m_datas["letter_footer"];
						$this->unsubcribe = $this->m_datas["unsubcribe_txt"];
						$this->unsubcribe_url = $this->m_datas["unsubcribe_url"];
						
						$file = "newsletter_patron.html";
						if( !file_exists( "skins/".$GLOBALS['babSkin']."/templates/". $file ) )
						{			
							$filepath = nl_relativePath(). $file;
						} else {
							$filepath = $file;
						}
						
						if($message === null){
							$message = bab_printTemplate($this, $filepath, $this->m_letter2Send['patron']);
							$mailEmbeddedImage = array();
		
							$sizeMail = 0;
							//embeded img
							if($this->m_letter2Send['embeded'] == '1'){
								preg_match_all('/<img[^>]+>/i',$message, $resultImg);
								
								$imgs = array();
								$indexImage = 0;
								foreach($resultImg[0] as $img_tag)
								{
								    preg_match_all('/(src)=("[^"]*")/i',$img_tag, $imgs[$indexImage]);
								    $imgs[$indexImage]['tag'] = $img_tag;
								    $indexImage++;
								}
	
								foreach($imgs as $img){
									$originalPath = str_replace('"', '', $img[2][0]);
									$nameArray = explode('/', $originalPath);
									$fileName = array_pop($nameArray);
									$cid = md5($originalPath);
									$mimetype = bab_getFileMimeType($originalPath);
									
									$addonInfos = bab_getAddonInfosInstance('newsletter');
									$babPath = new bab_Path($addonInfos->getUploadPath());
									$babPath->createDir();
									$handle = fopen($addonInfos->getUploadPath().$fileName, "w");
									if($handle){
										fwrite($handle, file_get_contents($originalPath));
										fclose($handle);
									}
									
									$fpath = $addonInfos->getUploadPath().$fileName;
									
									$styles = array();
									$w = 9999;
									$h = 9999;
									$returnStyle = preg_match_all('/style="([^"]*)"/i',$img['tag'], $styles);
									if($returnStyle && isset($styles[1]) && isset($styles[1][0])){
										$sizes = explode(';', $styles[1][0]);
										foreach($sizes as $size){
											$temp = explode(':', $size);
											foreach($temp as $k => $v){
												$temp[$k] = strtolower(trim($v));
											}
											if(isset($temp[1]) && substr($temp[1], -2) == 'px'){
												if($temp[0] == 'width'){
													$w = str_replace('px', '', $temp[1]);
												}elseif($temp[0] == 'height'){
													$h = str_replace('px', '', $temp[1]);
												}
											}
										}
										if ($T = @bab_functionality::get('Thumbnailer')){
											/*@var $T Func_Thumbnailer */
											$T->setSourceFile($fpath);
											
											$fpath = $T->getThumbnailPath($w, $h);
											$fpath = $fpath->tostring();
										}
									}
									
									$sizeMail+= filesize($fpath);
									
									$mailEmbeddedImage[$cid] = array('path' => $fpath, 'filename' => $fileName, 'mimtype' => $mimetype);
									$message = str_replace($originalPath, 'cid:'.$cid, $message);
								}
							}
		
							$sizeMail+= strlen($message);
							$sizeMail = $sizeMail / 1024;
							$messageNoHtml = strip_tags($message);
						
							foreach($mailEmbeddedImage as $cid => $image){
								$mail->mailEmbeddedImage($image['path'], $cid, $image['filename'], "base64", $image['mimtype']);
							}
						}
						
						$realMessage = str_replace('_IDSUB_', $subscribers['id'], $message);
						
						$mail->mailBody($realMessage, "html");
						$mail->mailAltBody($messageNoHtml);
						
						$registry = bab_getRegistryInstance();
						$registry->changeDirectory('/newsletter');
						$value = $registry->getValue('size', 0);
						
						if($value == 0 || $sizeMail <= $value){ 
							
							$Spooler = @bab_functionality::get('Mailspooler');
							/*@var $Spooler Func_Mailspooler */
							if ($Spooler)
							{
								$spoolerHash = $Spooler->save($mail);
								$requete =
									'INSERT INTO nl_letter_subscribers ( `id_letter`, `id_subscribers`, `hash`) ' .
									"VALUES ( '".$this->m_letter2Send['id_letter']."','".$subscribers['id']."','".$spoolerHash."')";
								
								$this->m_db->db_query($requete);
							}else{
								$mail->send();
							}
							
// 							$log->write('sendEmailByA : ' . '******** Email Envoy ******** emailTo[' . $email . '] subId['.$subscribers['id'].']');
// 							$log->write("\r\n");
// 							$endTime = microtime(true);
// 							$elapseTime = $endTime-$startTime;
// 							$log->write('elapseTime : ' . $elapseTime .'(secondes) ' . $endTime . ' - ' . $startTime);
// 							$log->write("\r\n");
// 							$log->write("\r\n");
		
							$mail->clearTo();
						}else{
							$requete = "UPDATE nl_letter SET date_envoi = NULL WHERE id = '". $this->m_letter2Send['id_letter'] . "'";
							$this->m_db->db_query($requete);
							header('location:' . nl_url() . 'users&idx=writeletter&oversize=1&draft=Y&id_letter='.$this->m_letter2Send['id_letter'].'&id_newsletter_topic='.$_GET['nlID']);
							die;
						}
					}
				}
			}
			else
			{
// 				$log->write('sendEmailByA : ' . 'query erreur');
// 				$log->write("\r\n");
// 				$log->write("\r\n");

			}
// 			$log->write('sendEmailByA : ' . 'END SENDING');
// 			$log->write("\r\n");
// 			$log->write("\r\n");
			header('location:' . nl_url() . 'users&idx=okSendLetter&id=' . $this->m_letter2Send['id_letter']);
		}
	}

	class logFile 
	{
		var $filename;

		function logFile($file)
		{
			$this->filename = $file;
		}

		function write($message)
		{
			$fc = fopen($this->filename, "a+");
			/*$w = */fwrite ($fc, $message ); 
			fclose($fc);
		}
	}

	class raw2HtmlClass
	{
		function raw2HtmlClass()
		{
		}

		function transform(& $value, $key)
		{
			if(false === is_numeric($value))
			{
				$value = raw_2_html($value);
			}
		}
	}


	class Pagination
	{
		var $m_html_datas;

		function Pagination()
		{
			$this->m_html_datas = array();

			$this->m_html_datas['page_url'] = '';
			$this->m_html_datas['filter_url'] = '';

			/* Valeur par dfaut */
			$this->m_html_datas['prev']	= nl_translate("Prev");
			$this->m_html_datas['next']	= nl_translate("Next");

			/* Variables filter */
			$this->m_html_datas['filters'] = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$this->m_html_datas['filter_tab'] = array();
			$this->m_html_datas['filter_text'] = '';
			$this->m_html_datas['current_filter'] = '';
			$this->m_html_datas['is_filter_url'] = 0;
			$this->m_html_datas['filter_url'] = '';
			$this->m_html_datas['all_filter']	= true;
			$this->m_html_datas['current_filter'] = 'All';

			$this->m_html_datas['start_link'] = 0;
			$this->m_html_datas['end_link'] = 0;
			$this->m_html_datas['nb_link'] = 0;

			/* Variables page */
			$this->m_html_datas['num_of_pages'] = 0;
			$this->m_html_datas['nb_row_per_page'] = 0;
			$this->m_html_datas['total_num_of_rows'] = 0;
			$this->m_html_datas['current_page'] = 0;

			$this->m_html_datas['is_prev_url'] = 0;
			$this->m_html_datas['is_next_url'] = 0;
			$this->m_html_datas['is_page_url'] = 0;
			$this->m_html_datas['prev_page_url'] = '';
			$this->m_html_datas['next_page_url'] = '';
			$this->m_html_datas['page_url'] = '';
			$this->m_html_datas['prev_page_text'] = '';
			$this->m_html_datas['page_text'] = '';
			$this->m_html_datas['next_page_text'] = '';

			$this->m_html_datas['template_page_url'] = '';
			$this->m_html_datas['template_filter_url'] = '';
			
			$this->m_html_datas['attribut']	= 'none';
			$this->m_html_datas['attribut_translation'] = array();
			$this->m_html_datas['table_name'] = '';
			$this->m_html_datas['template_filter_path'] = '';
			$this->m_html_datas['template_filter_name'] = '';
			$this->m_html_datas['template_page_path'] = '';
			$this->m_html_datas['template_page_name'] = '';
		}

		function get_data($property_name, &$property_value)
		{
			if(isset($this->m_html_datas[$property_name]))
			{
				$property_value = $this->m_html_datas[$property_name];
				return true;
			}
			return false;
		}

		function set_data($property_name, $property_value)
		{
			$this->m_html_datas[$property_name] = $property_value;
			return true;
		}

		/* calcul l'offset de dbut et de fin */
		function compute_start_end_pos()
		{
			$this->m_html_datas['num_of_pages']	= 0;
			$this->m_html_datas['end_link']		= 0;
			$this->m_html_datas['start_link']	= 1;

			if( $this->m_html_datas['nb_row_per_page'] > 0 && 
				$this->m_html_datas['total_num_of_rows'] > $this->m_html_datas['nb_row_per_page']
			  )
			{
				$this->m_html_datas['num_of_pages'] = 
					ceil($this->m_html_datas['total_num_of_rows'] / $this->m_html_datas['nb_row_per_page']);
			}

			if($this->m_html_datas['current_page'] >= $this->m_html_datas['nb_link'])
			{
				$this->m_html_datas['start_link'] = $this->m_html_datas['current_page'] - $this->m_html_datas['nb_link'];
				if(0 >= $this->m_html_datas['start_link'])
				{
					$this->m_html_datas['start_link'] = 1;
				}
			}

			if(($this->m_html_datas['current_page'] + $this->m_html_datas['nb_link']) > $this->m_html_datas['num_of_pages'])
			{
				$this->m_html_datas['end_link'] = $this->m_html_datas['num_of_pages'];
			}
			else
			{
				$this->m_html_datas['end_link'] = $this->m_html_datas['current_page'] + $this->m_html_datas['nb_link'];
			}
		}

		function build_prev_page_url()
		{
			if( $this->m_html_datas['current_page'] > 1 && 
				$this->m_html_datas['current_page'] <= $this->m_html_datas['num_of_pages'])
			{
				$prev_page								= $this->m_html_datas['current_page'] - 1;
				$this->m_html_datas['is_prev_url']		= 1;
				$this->m_html_datas['prev_page_url']	= $this->build_page_url($prev_page);
				$this->m_html_datas['prev_page_text'] = $this->m_html_datas['prev'];
			}
			else
			{	
				$this->m_html_datas['is_prev_url'] = 0;
				$this->m_html_datas['current_page'] = 1;
				$this->m_html_datas['prev_page_text'] = '';
			}
		}

		function build_next_page_url()
		{
			if( $this->m_html_datas['current_page'] >= 1									&& 
				$this->m_html_datas['current_page'] < $this->m_html_datas['num_of_pages']	&& 
				(($this->m_html_datas['total_num_of_rows'] - ($this->m_html_datas['nb_row_per_page'] * 
					$this->m_html_datas['current_page'])) > 0) 
			  )
			{
				$next_page = $this->m_html_datas['current_page'] + 1;
				$this->m_html_datas['next_page_text'] = $this->m_html_datas['next'];
				$this->m_html_datas['is_next_url']		= 1;
				$this->m_html_datas['next_page_url']	= $this->build_page_url($next_page);
			}
			else
			{
				$this->m_html_datas['is_next_url'] = 0;
				$this->m_html_datas['next_page_text'] = '';
			}
		}

		
		function get_next_page()
		{
			$this->m_html_datas['page_text'] = $this->m_html_datas['start_link'];

			if( $this->m_html_datas['start_link'] != $this->m_html_datas['current_page'] )
			{
				$this->m_html_datas['is_page_url'] = 1;
				$this->m_html_datas['template_page_url'] = $this->build_page_url($this->m_html_datas['start_link']);
			}
			else
			{
				$this->m_html_datas['is_page_url'] = 0;
			}

			if($this->m_html_datas['start_link'] <= $this->m_html_datas['end_link'])
			{
				$this->m_html_datas['start_link']++;
				return true;
			}
			else 
			{
				return false;
			}
		}

		function build_url($url, $page_number, $filter, $attribut)
		{
/*
			$vars = array('page' => $page_number, 'filter' => $filter, 'attribut' => $attribut);

			$formated_vars = array();

			foreach($vars as $key => $value)
			{
				$formated_vars[] = urlencode($key) . '=' . urlencode($value);
			}

			return $this->m_html_datas['url'] . htmlentities('&') . htmlentities(join('&', $formated_vars));
*/

			
			$url = htmlentities(sprintf($url, $page_number, $filter, $attribut));
			return $url;
		}

		function build_filter_url($filter)
		{
			return $this->build_url($this->m_html_datas['filter_url'], 1, 
				$filter, $this->m_html_datas['attribut']);
		}

		function build_page_url($page_number)
		{
			return $this->build_url($this->m_html_datas['page_url'], $page_number, 
				$this->m_html_datas['current_filter'], $this->m_html_datas['attribut']);
		}

		function get_multipage()
		{
			$html = '';
			
			$this->compute_start_end_pos();

			$this->build_prev_page_url();

			$this->build_next_page_url();

			return bab_printTemplate($this, $this->m_html_datas['template_page_path'], 
				$this->m_html_datas['template_page_name']);
		}

		function get_status_line()
		{
			$nb_row_per_page = 0;
			$current_page = 0;
			$total_num_of_rows = 0;
			$start = 0;
			$end = 0;
			$num_of_pages = 0;

			if(isset($this->m_html_datas['nb_row_per_page']))
			{
				$nb_row_per_page = $this->m_html_datas['nb_row_per_page'];
			}
			
			if(isset($this->m_html_datas['current_page']))
			{
				$current_page = $this->m_html_datas['current_page'];
			}

			if(isset($this->m_html_datas['total_num_of_rows']))
			{
				$total_num_of_rows = $this->m_html_datas['total_num_of_rows'];
			}

			if($nb_row_per_page > 0)
			{
				$num_of_pages = ceil($total_num_of_rows / $nb_row_per_page);

				$start = (($current_page * $nb_row_per_page) - $nb_row_per_page) + 1;
				$end   = ($current_page * $nb_row_per_page);
			}

			$format = nl_translate("Result from %d to %d (%d Results / %d Pages)");
			return htmlentities(sprintf($format, $start, $end, $total_num_of_rows, $num_of_pages));
		}

		function get_next_letter()
		{
			$filter = each($this->m_html_datas['filter_tab']);

			if(false != $filter)
			{
				/*
					La fonction each retourne un tableau associatif
					dont une des cles est 'value'
				*/
				$this->m_html_datas['filter_text'] = $filter['key'];

				$is_filter = ($filter['key'] == $this->m_html_datas['current_filter']) ? 0 : (int) $filter['value'];

				$this->m_html_datas['is_filter_url'] = $is_filter;

				$this->m_html_datas['template_filter_url'] = $this->build_filter_url($this->m_html_datas['filter_text']);

				return true;
			}
			else
			{
				reset($this->m_html_datas['filter_tab']);
				return false;
			}
		}

		function get_alphapage($topic_id)
		{
			/* Si on  une table de traduction ou pas pour les attributs */
			$attribut = '';
			if('none' != $this->m_html_datas['attribut'])
			{
				$attribut = $this->m_html_datas['attribut_translation'][$this->m_html_datas['attribut']];
			}
			else
			{
				$attribut = $this->m_html_datas['attribut'];
			}

			/* Si on veut que All soit rajout ou pas */
			$query = '';
			if(true == $this->m_html_datas['all_filter'])
			{
				$query = 'SELECT \'1\' AS \'All\', ';
			}
			else
			{
				$query = 'SELECT ';
			}

			$chars = preg_split('//', $this->m_html_datas['filters'], -1, PREG_SPLIT_NO_EMPTY);

			if('none' != $attribut)
			{
				foreach($chars as $key => $value)
				{
					$query .= 'SUM( ' . $attribut . 
						' LIKE \'' . $value . '%\') ' . $value . ',';
				}
			}
			else
			{
				foreach($chars as $key => $value)
				{
					$query .= '1 AS \'' . $value . '\',';
				}
			}

			$query = substr($query, 0, strlen($query) - 1) . ' FROM ' . $this->m_html_datas['table_name'] .
				' WHERE id_newsletter_topic = \'' . $topic_id . '\'';

			$db = new nlDB;

			//echo $query . '<br />';

			$result_count = $db->db_query($query);
			$this->m_html_datas['filter_tab'] = $db->db_fetch_assoc($result_count);

			return bab_printTemplate($this, $this->m_html_datas['template_filter_path'], 
				$this->m_html_datas['template_filter_name']);
		}
	}
?>
