<?PHP

require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');
require_once(dirname(__FILE__) . '/nlDataBase.php'); 


function nl_translate($str)
{
	return bab_translate($str, 'newsletter');
}

/**
 * Initialize mysql ORM backend.
 */
function nl_loadOrm()
{
	if (!class_exists('ORM_MySqlRecordSet'))
	{
		$Orm = bab_functionality::get('LibOrm');
		/*@var $Orm Func_LibOrm */
		$Orm->initMySql();
		
		$mysqlbackend = new ORM_MySqlBackend($GLOBALS['babDB']);
		ORM_MySqlRecordSet::setBackend($mysqlbackend);
	}
}

function nl_addonInfo()
{
	$addonName = 'newsletter';
	$addonInfo = bab_getAddonInfosInstance($addonName);
	
	return $addonInfo;
}

function nl_getUploadPath()
{
	$addon = nl_addonInfo();

	$upload = $addon->getUploadPath();
	
	if(!is_dir($upload)){
		require_once $GLOBALS['babInstallPath'].'utilit/path.class.php';
		$babPath = new bab_Path($upload);
		$babPath->createDir();
	}
	
	return $upload;
}

function nl_relativePath()
{
	$ai = nl_addonInfo();
	return $ai->getRelativePath();
}

function nl_url()
{
	$ai = nl_addonInfo();
	return $ai->getUrl();
}

/**
 * Test if field exists
 * @param	string	$table
 * @param	string	$field
 * @return 	boolean
 */
function nl_isTableField($table, $field) {
	global $babDB;

	$arr = $babDB->db_fetch_array($babDB->db_query('DESCRIBE '.$table.' '.$field));
	return ($arr[0] == $field);
}


function implodeUserGroup($stringGlue)
{
	if(true == bab_userIsloggedin())
	{
		$currentUserGroups = bab_getUserGroups(bab_getUserId($GLOBALS['BAB_SESS_NICKNAME']));

		//Pour aller plus vite apres les classer par NOT NULL
		//ou peut tre que ce serai mieux de faire trois requte
		if(true === isSet($currentUserGroups['id']) && count($currentUserGroups['id']))
		{
			return implode($stringGlue, $currentUserGroups['id']) . ',' . EVERYBODY_GROUP . ',' .
				REGISTERED_USERS_GROUP;
		}
	}

	return UNREGISTERED_USERS_GROUP . ',' . EVERYBODY_GROUP;
}

function getUserAccess()
{
/*	
	$query = 
		'SELECT ' .
			'* ' .
		'FROM nl_newsletter_topic nl';

	//echo $query . '<br />';

	$usrType = 0;

	$db = new nlDB();
	$result = $db->db_query($query);
	$numrows = $db->db_num_rows($result);

	$idx = 0;
	$is_all_access = false;
	while($idx < $numrows &&  !$is_all_access && false != ($data = $db->db_fetch_assoc($result)))
	{
		if( bab_isAccessValid(NL_MANAGERS_GROUP, $data['id']) )
		{
			$usrType |= MANAGER;
		}
		
		if( bab_isAccessValid(NL_WRITERS_GROUP, $data['id']) )
		{
			$usrType |= WRITER;
		}

		if( bab_isAccessValid(NL_USERS_GROUP, $data['id']) )
		{
			$usrType |= USER;
		}

		$is_all_access = ( MANAGER == ($usrType & MANAGER) && WRITER == ($usrType & WRITER) && USER == ($usrType & USER) );
		++$idx;
	}
*/
	$usrType = 0;

	if( count(bab_getUserIdObjects(NL_MANAGERS_GROUP)) > 0 )
	{
		$usrType |= MANAGER;
	}
	
	if( count(bab_getUserIdObjects(NL_WRITERS_GROUP)) > 0 )
	{
		$usrType |= WRITER;
	}

	if( count(bab_getUserIdObjects(NL_USERS_GROUP)) > 0 )
	{
		$usrType |= USER;
	}

	return $usrType;
}


function nl_escapeString($value)
{
	global $babDB;
	return $babDB->db_escape_string($value);
}

function nl_stripSlashes($value)
{
	return stripSlashes($value);
}

function raw_2_html($value)
{
	return bab_toHtml($value);
}

/**
 * Instanciates the widget factory.
 *
 * @return Func_Widgets
 */
function nl_WidgetFactory()
{
	$W = bab_Functionality::get('Widgets');
	assert('$W instanceof Func_Widgets; /* Could not instanciate the Func_Widgets functionality. */');
	
	// Includes definitions of stock icons.
	$W->includePhpClass('Widget_Icon');

	return $W;
}

?>