<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2008 by CANTICO ({@link http://www.cantico.fr})
 */
include_once 'base.php';
require_once dirname(__FILE__).'/../nlincl.php';


bab_Widgets()->includePhpClass('Widget_BabTableModelView');
bab_Widgets()->includePhpClass('Widget_Form');
bab_Widgets()->includePhpClass('Widget_Frame');


class nl_letter_subscribersTableView extends Widget_BabTableModelView
{
	public function addDefaultColumns(nl_letter_subscribersSet $set)
	{
		//$this->addClass(Func_Icons::ICON_LEFT_16);
		
		$this->addColumn(widget_TableModelViewColumn($set->id_subscribers->last_name, nl_translate('Lastname'))->addClass('widget-strong'));
		$this->addColumn(widget_TableModelViewColumn($set->id_subscribers->first_name, nl_translate('Firstname'))->addClass('widget-strong'));
		$this->addColumn(widget_TableModelViewColumn($set->id_subscribers->email, nl_translate('Email'))->addClass('widget-strong'));
		$this->addColumn(widget_TableModelViewColumn('_status_', nl_translate('Status')));
	}
	
	/**
	 * @param ORM_Record	$record
	 * @param string		$fieldPath
	 * @return Widget_Item
	 */
	protected function computeCellContent(nl_letter_subscribers $record, $fieldPath)
	{
		$W = bab_Widgets();
		
		if ('_status_' === $fieldPath)
		{
			$nl_addonInfo = nl_addonInfo();
			$path = $nl_addonInfo->getImagesPath();
			$status = '';
			if($record->sent_status === null){
				$status = nl_translate('In wait');
				$icon = $path.'22x22/mail-mark-unread-new.png';
			}elseif($record->sent_status == 0){
				$status = nl_translate('Failed');
				$icon = $path.'22x22/mail-mark-important.png';
			}elseif($record->sent_status == 1){
				$status = nl_translate('Sent');
				$icon = $path.'22x22/mail-mark-notjunk.png';
			}
			if($record->error_msg){
				$status.= $record->error_msg;
			}
			
			return $W->Image($icon, $status)->setTitle($status);
			/*return $W->Link(
				$W->Icon('', Func_Icons::ACTIONS_EDIT_DELETE),
				workschedules_Controller()->Profile()->removeUser($record->user)
			)->setConfirmationMessage(nl_translate('This will remove this user from the work schedule profile definition ?'));*/
		}
		
		return parent::computeCellContent($record, $fieldPath);
	}
}