<?php
require_once(dirname(__FILE__) . '/nlincl.php');
require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');



function displayNewsletterList()
{
	addDefaultMenu();
	
	require_once dirname(__FILE__) . '/helper/userNewsletterListDataSource.class.php';
	
	$oMultiPage = new NL_MultiPageBase();
	$oMultiPage->sIdx = 'displayNewsletterList';

	$oMultiPage->setColumnDataSource(new NL_UserNlListDataSource());
	$oMultiPage->addColumnHeader(new NL_ColumnHeader(0, nl_translate("Name"), 'sName', false));
	$oMultiPage->addColumnHeader(new NL_ColumnHeader(1, nl_translate("Description"), 'sDescription', false));
	
	//To bypass a bug in the NL_MultiPageBase class, the idx is not passed
	//in the prev and next link
	$oMultiPage->addPaginationAndFormParameters('idx', 'displayNewsletterList');
	
	$sTg = bab_rp('tg', 'addon/newsletter' . '/users');
	
//*
	//Pour les icnes
	{		
		$aDataSourceFields = array(
			array('sDataSourceFieldName' => 'iId', 'sUrlParamName' => 'id')
		);
		
		if(true === bab_userIsloggedin())
		{
			$oMultiPage->addActionExcludeFilter('suscribe', 'iIdSus', '!=', '0');
			$oMultiPage->addActionExcludeFilter('unsuscribe', 'iIdSus', '==', '0');
		}
		
		$sLink = $GLOBALS['babUrlScript'] . '?tg=' . urlencode($sTg) . '&idx=' . urlencode('subscribe');
		$oMultiPage->addAction('suscribe', nl_translate("Subscribe"), 
			$GLOBALS['babSkinPath'] . 'images/addons/newsletter/mail_get.png', 
			$sLink, $aDataSourceFields);
			
		$sLink = $GLOBALS['babUrlScript'] . '?tg=' . urlencode($sTg) . '&idx=' . urlencode('unsubscribe');
		$oMultiPage->addAction('unsuscribe', nl_translate("unsubscribe"), 
			$GLOBALS['babSkinPath'] . 'images/addons/newsletter/mail_delete.png', 
			$sLink, $aDataSourceFields);
	}
//*/
	
	global $babBody;
//	$babBody->title = nl_translate("Newsletter who you can subscribe");
	$babBody->babecho($oMultiPage->printTemplate());
}



/* 
	User function:
		Liste toutes les newsletters pour lesquelles 
		l'utilisateur courant peut souscrire et pour 
		lesquelles il n'a pas deja souscrit
*/
function listUserNewsletters()
{
	$usrLoggedIn = bab_userIsloggedin();
	$subscriberID = $id_ov_user = '';

	if(true === $usrLoggedIn)
	{
		$id_ov_user		= ' AND id_ov_user = ' . $GLOBALS['BAB_SESS_USERID'];
		$subscriberID	= ' sus.id IS NULL AND';
	}
	else
	{
		$id_ov_user		= ' AND id_ov_user = 0';
		$subscriberID	= ' ';
	}

	$hrefValue = nl_url() . 'users&idx=subscribe&id=';

	$nl_topic_id = array_keys(bab_getUserIdObjects(NL_USERS_GROUP));

	//print_r(bab_getUserIdObjects('nl_users_groups'));

	$query =
		'SELECT ' . 
			'nl.id, ' .
			'name, ' .
			'description, ' .
			'sus.id_ov_user, ' .
			'sus.id susID ' .
		'FROM ' . 
			NL_NEWSLETTER_TOPIC . ' nl ' .
		'LEFT JOIN ' . 
			NL_SUBSCRIBERS . ' sus ON nl.id = sus.id_newsletter_topic ' . $id_ov_user . ' ' .
		'WHERE ' .
			$subscriberID . ' ' .
			'nl.id IN(\'' . implode("','", $nl_topic_id) . '\') AND ' .
			'nl.disabled != 1 ' .
		'GROUP BY ' .
			'name ' .
		'ORDER BY ' . 
			'name ' .
		'ASC';

	//echo $query . '<br />';

	$newsletters = new NewsletterInfo($query);

	$newsletters->set_anchor($hrefValue,
		$GLOBALS['babSkinPath'] . 'images/Puces/PuceEnregistered.gif',
		nl_translate("Subscribe"));

	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('edit_url', $hrefValue);

	global $babBody;
	$babBody->title = nl_translate("Newsletter who you can subscribe");

	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'common.html', 'nlList'));

	addDefaultMenu();
}


/* 
	User function:
		Liste toutes les newsletters pour lesquelles l'utilisateur
		est inscrit
*/
function listSubscribedNewsletter()
{
	$usrLoggedIn = bab_userIsloggedin();
	$subscriberID = $id_ov_user = $hrefValue = '';

	if(true === $usrLoggedIn)
	{
		$subscriberID = 'sus.id_ov_user = ' . $GLOBALS['BAB_SESS_USERID'];
		$hrefValue = nl_url() . 
			'users&idx=unsubscribe&id=';
	}
	else
	{
		$subscriberID	= 'sus.id_ov_user = 0';
		$hrefValue = nl_url() . 
			'users&idx=unsubscribe&id=';
	}

	$userGprList = implodeUserGroup(',');

	$query = 
		'SELECT DISTINCT ' .
			'sus.id_newsletter_topic id, ' .
			'nl.name, ' .
			'nl.description, ' .
			'sus.id sus_id ' .
		'FROM ' . 
			NL_SUBSCRIBERS . ' sus ' .
		'LEFT JOIN ' . 
			NL_NEWSLETTER_TOPIC . ' nl ON nl.id = sus.id_newsletter_topic ' .
		'WHERE ' . 
			$subscriberID . ' AND ' .
			'nl.disabled != 1 ' .
		'GROUP BY name ' .
		'ORDER BY name asc';

	//echo $query . '<br />';

	$newsletters = new NewsletterInfo($query);

	$newsletters->set_anchor($hrefValue,
		$GLOBALS['babSkinPath'] . 'images/Puces/PuceEnregistered.gif',
		 nl_translate("unsubscribe"));

	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('edit_url', $hrefValue);

	global $babBody;
	$babBody->title = nl_translate("Newsletter who you have subscribed");

	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'common.html', 'nlListSubscribed'));

	addDefaultMenu();
}


/* 
	User function:
		$action == 'subscribe'
*/
function subscribe($action)
{
	//Si c'est un utilisateur loggu ou si c'est une confirmation d'inscription
	if((true === bab_userIsloggedin() && !bab_isAccessValid(NL_INSCRIPTION_GROUP, $_GET['id'])) || isset($_GET['sub_id']))
	{
		processSubcription();
	}
	else
	{
		showSubscriptionForm($action);
	}
}

/* 
	User function:
		$action == 'unsubscribe'
*/
function unsubscribe($action)
{
	//Si c'est un utilisateur loggu ou si c'est une confirmation de dsinscription
	if((true === bab_userIsloggedin() && !bab_isAccessValid(NL_INSCRIPTION_GROUP, $_GET['id'])) || isset($_GET['sub_id']))
	{
		processUnsubcription();
	}
	else
	{
		showSubscriptionForm($action);
	}
}


function showSubscriptionForm($action)
{
	global $babBody;

	$baseFormProcessing = new BaseFormProcessing();

	$attributs = array('id' => $_GET['id'], 'name' => '',
		'smtp_msg_sent_by_loop' => 0, 'subscription_validation' => 0);

	$tableWrapper = new	TableWrapper(NL_NEWSLETTER_TOPIC);
	$attributs = $tableWrapper->load($attributs, 0, 4, 0, 1);

	if(false != $attributs)
	{
		if($action == 'subscribe')
		{
			$babBody->title = nl_translate("Subscribe to the newsletter : ") . $attributs['name'];
			$baseFormProcessing->set_caption('submit', nl_translate("Subscribe"));
		}
		else if($action == 'unsubscribe')
		{
			$babBody->title = nl_translate("Unsubscribe to the newsletter : ") . $attributs['name'];
			$baseFormProcessing->set_caption('submit', nl_translate("Unsubscribe"));
		}

		$baseFormProcessing->set_caption('action', $action);
		$baseFormProcessing->set_caption('first_name', nl_translate("First Name"));
		$baseFormProcessing->set_caption('last_name', nl_translate("Last Name"));
		$baseFormProcessing->set_caption('email', nl_translate("E-mail Address"));
		$baseFormProcessing->set_caption('invalide username', nl_translate("invalide username"));
		$baseFormProcessing->set_caption('invalide email', nl_translate("invalide email"));
		$baseFormProcessing->set_caption('invalid file', nl_translate("This field must be filled"));
		$baseFormProcessing->set_caption('subscription', nl_translate("Subcription"));

		$baseFormProcessing->set_data('email', '');
		$baseFormProcessing->set_data('first_name', '');
		$baseFormProcessing->set_data('last_name', '');

		while(list($key, $val) = each($attributs)) 
		{
			$baseFormProcessing->set_data($key, $val);
		}

		$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);
//		$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

		addDefaultMenu();

		$babBody->addItemMenu($action, nl_translate("Subcription"), nl_url().'users');

		$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'user.html', "subscribe"));
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("ERROR : Cannot load newsletter informations");
	}
}











// ----------------------------------------------------------------------- //
// Traitemant
// ----------------------------------------------------------------------- //


/* 
	User function:
		Un utilisateur qui ne fait partie d'ovidentia s'abonne.
		Il est enregistr temporairement ou definitivement selon
		que l'abonnement  la newsletter doit tre confirm ou non.
*/
function processUserSubcription()
{
// Tester l'email sinon reposter
//	'email' => $_POST['email'],
	processSubcription();
}


function processSubcription()
{
	$tableWrapper = new TableWrapper(NL_SUBSCRIBERS);

	$subcriberID = -1;
	$topicID = (isset($_GET['id']) ? $_GET['id'] : $_POST['id']);
	$usrLoggedIn = bab_userIsloggedin() && !bab_isAccessValid(NL_INSCRIPTION_GROUP, $topicID);
	
	$ret = subscribe2nl($usrLoggedIn, $tableWrapper, $subcriberID);

	if(SHOW_WELCOME_MSG === $ret)
	{
		$welcomeEmail = buildWelcomeEmail($topicID, $subcriberID, $usrLoggedIn, $tableWrapper);

		if(false != $welcomeEmail)
		{
			$susbcription2Send = new SendSubscriptionInfo($welcomeEmail);

			$emailSended = $susbcription2Send->send();

			$GLOBALS['g_idx'] = '';

			$msg = nl_translate("Welcome to the newsletter ") . $welcomeEmail['name'] . 
				((true === $emailSended) ? nl_translate(" a message have been sent to :") . $welcomeEmail['email']
				 : '');

			showMsg($welcomeEmail['name'], $msg);

			if(false === $emailSended)
			{
				$GLOBALS['babBody']->msgerror = nl_translate("Error while attempting to send a welcome message");
			}
		}
	}
	else if(SHOW_CONFIRM_SUBCRIPTION_MSG === $ret)
	{
		$confirmationEmail = buildSubcriptionConfirmationEmail($topicID, $subcriberID, $usrLoggedIn, $tableWrapper);

		if(false != $confirmationEmail)
		{
			$susbcription2Send = new SendSubscriptionInfo($confirmationEmail);
			if(true === $susbcription2Send->send())
			{
				$GLOBALS['g_idx'] = '';

				$msg = nl_translate("To confirm your subscription to the newsletter ") . $confirmationEmail['name'] . 
					nl_translate(" please respond to the message that have been sent to :") . $confirmationEmail['email'];

				showMsg($confirmationEmail['name'], $msg);
			}
			else
			{
				$tableWrapper->setTableName(NL_SUBSCRIBERS);

				$subscriber = array('id' => $subcriberID);

				if(false === $tableWrapper->delete($subscriber))
				{
					$GLOBALS['babBody']->msgerror = 
						nl_translate("ERROR cannot delete user, to register please contact the administrator");
				}
				else
				{
					$GLOBALS['babBody']->msgerror = 
						nl_translate("Error while attempting to send the subscription confirmation message please register again");
				}
			}
		}
	}
}


//Peux tre appel par POST ou GET
//Doit retourner le message  afficher
function subscribe2nl($usrLoggedIn, & $tableWrapper, & $subcriberID)
{
	$selectParam = 0;
	$whereParam = 0;
	$retVal = ERROR;
	$subscriber = array();

	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_SUBSCRIBERS);

	if(true == $usrLoggedIn)
	{
		//Enregistrement d'un utilisateur loggu
		$ses_user_id = $GLOBALS['BAB_SESS_USERID'];
		$email = bab_getUserEmail($ses_user_id);
//		$name = explode(" ", bab_getUserName($ses_user_id));

		$subscriber = array(
			'id_ov_user' => $ses_user_id, 
			'id_newsletter_topic' => $_GET['id'], 
			'subscription' => SUBSCRIPTION_CONFIRMED,
			'email' => nl_escapeString($email),
			'first_name' => nl_escapeString($GLOBALS['BAB_SESS_FIRSTNAME']), 
			'last_name' => nl_escapeString($GLOBALS['BAB_SESS_LASTNAME']));

		$retVal = SHOW_WELCOME_MSG;
		$selectParam = $whereParam = count($subscriber);
	}
	else if( isset($_GET['sub_id']) )
	{
		//Confirmation d'enregistrement d'un utilisateur non loggu 
		$subscriber = array(
			'id_ov_user' => 0, 
			'id_newsletter_topic' => $_GET['id'], 
			'id' => $_GET['sub_id'],
			'subscription' => SUBSCRIPTION_TO_CONFIRME);

		$retVal = SHOW_WELCOME_MSG;
		$selectParam = $whereParam = 4;
	}
	else
	{
		//Enregistrement d'un utilisateur non loggu
		$subscriber = array(
			'id_ov_user' => 0, 
			'id_newsletter_topic' => $_POST['id'], 
			'email' => nl_escapeString($_POST['email']),
			'first_name' => nl_escapeString($_POST['first_name']), 
			'last_name' => nl_escapeString($_POST['last_name'])); 

		$selectParam = $whereParam = 3;
		if(SUBSCRIPTION_NOT_NEEDED == $_POST['subscription_validation'])
		{
			$retVal = SHOW_WELCOME_MSG;
			$subscriber['subscription'] = SUBSCRIPTION_CONFIRMED;
		}
		else if(SUBSCRIPTION_NEEDED == $_POST['subscription_validation'])
		{
			$subscriber['subscription'] = SUBSCRIPTION_TO_CONFIRME;
			$retVal = SHOW_CONFIRM_SUBCRIPTION_MSG;
		}
		else
		{
			$GLOBALS['babBody']->msgerror = nl_translate("You cannot subscribe to this newsletter please contact the administrator");
			$retVal = ERROR;
		}
	}

	// si il n'y a pas d'erreur
	if(ERROR !== $retVal)
	{
		//Si c'est une confirmation
		if( isset($_GET['sub_id']) )
		{
			if(false !== $tableWrapper->load($subscriber, 0, $selectParam, 0, $whereParam))
			{
				$subscriber['subscription'] = SUBSCRIPTION_CONFIRMED;

				if(true === $tableWrapper->update($subscriber))
				{
					$subcriberID = $_GET['sub_id']; 
				}
				else
				{
					$GLOBALS['babBody']->msgerror = nl_translate("Error in subcription process");
					$retVal = ERROR;
				}
			}
			else
			{
				$GLOBALS['babBody']->msgerror = nl_translate("888 Error cannot process your subscription confirmation");
				$retVal = ERROR;
			}
		}
		else
		{
			//Si il n'est pas deja enregistr
			if(false === $tableWrapper->load($subscriber, 0, $selectParam, 0, $whereParam))
			{
				$subscriber['subscription_date'] = 'now()';
				if(true === $tableWrapper->save($subscriber, false, true))
				{
					$subcriberID = $tableWrapper->m_db->m_db->db_insert_id(); 
				}
				else
				{
					$GLOBALS['babBody']->msgerror = nl_translate("Error in subcription process");
					$retVal = ERROR;
				}
			}
			else
			{
				$GLOBALS['babBody']->msgerror = nl_translate("You have already subscribed to this newsletter");
				$retVal = ERROR;
			}
		}
	}

	$tableWrapper->setTableName($tableName);
	return $retVal;
}


function buildWelcomeEmail($topicID, $subscriberID, $usrLoggedIn, & $tableWrapper)
{
	$error = false;

	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_NEWSLETTER_TOPIC);

	$subscriptionInfo = array(
		'id' => $topicID,
		'name' => '',
		'welcome_subject' => '',
		'welcome_body' => '',
		'admin_email' => '',
		'admin_name' => ''
	);

	$subscriptionInfo = $tableWrapper->load($subscriptionInfo, 0, 6, 0, 1);

	if(false !== $subscriptionInfo)
	{
		$subscriptionInfo['subject'] = $subscriptionInfo['welcome_subject'];
		$subscriptionInfo['body'] = $subscriptionInfo['welcome_body'];

		unset($subscriptionInfo['welcome_subject']);
		unset($subscriptionInfo['welcome_body']);

		$subscriptionInfo['body'] .= nl_translate(" to unsubscribe please click to the link below");

		buildSubscriptionURL($subscriptionInfo, UNSUBSCRIPTION_CONFIRMATION_URL,
			$subscriberID, $topicID);

		$subscriptionInfo['confirmation_txt'] = '';
		$subscriptionInfo['confirmation_url'] = '';

		$email = '';
		if(false === getSubscriberEmail($usrLoggedIn, $subscriberID, $tableWrapper, $email))
		{
			$error = true;
		}
		else
		{
			$subscriptionInfo['email'] = $email;
		}
	}

	$tableWrapper->setTableName($tableName);

	if(false === $error)
	{
		return $subscriptionInfo;
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("Cannot built the subscription message");
		return false;
	}
}


function buildSubcriptionConfirmationEmail($topicID, $subscriberID, $usrLoggedIn, & $tableWrapper)
{
	$error = false;

	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_NEWSLETTER_TOPIC);

	$subscriptionInfo = array('id' => $topicID, 'name' => '',
		'admin_name' => '', 'admin_email' => '',
		'subscription_body' => '', 'subscription_subject' => '');

	$subscriptionInfo = $tableWrapper->load($subscriptionInfo, 0, 6, 0, 1);

	if(false != $subscriptionInfo)
	{
		$subscriptionInfo['subject'] = $subscriptionInfo['subscription_subject'];
		$subscriptionInfo['body'] = $subscriptionInfo['subscription_body'];
		
		unset($subscriptionInfo['subscription_subject']);
		unset($subscriptionInfo['subscription_body']);

		buildSubscriptionURL($subscriptionInfo, SUBSCRIPTION_CONFIRMATION_URL,
			$subscriberID, $topicID);

		buildSubscriptionURL($subscriptionInfo, UNSUBSCRIPTION_CONFIRMATION_URL,
			$subscriberID, $topicID);
	
		$email = '';
		if(false === getSubscriberEmail($usrLoggedIn, $subscriberID, $tableWrapper, $email))
		{
			$error = true;
		}
		else
		{
			$subscriptionInfo['email'] = $email;
		}
	}

	$tableWrapper->setTableName($tableName);

	if(false === $error)
	{
		return $subscriptionInfo;
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("Cannot built the subscription confirmation message");
		return false;
	}
}


function showMsg($topicName, $msg)
{
	global $babBody;

	$baseFormProcessing = new BaseFormProcessing();
	
	$baseFormProcessing->set_caption('ok', nl_translate("Ok"));
	$baseFormProcessing->set_caption('msg', $msg);
	$baseFormProcessing->set_caption('name', $topicName);

	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'user.html', "subscriberInfo"));
}


function getSubscriberEmail($usrLoggedIn, $subscriberID, &$tableWrapper, &$subscriberEmail)
{
	$retval = true;
	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_SUBSCRIBERS);


	if(false == $usrLoggedIn)
	{
		$subscriber = array('id' => $subscriberID, 'email' => '');
		$subscriber = $tableWrapper->load($subscriber, 1, 1, 0, 1);
		if(false != $subscriber)
		{
			$subscriberEmail = $subscriber['email'];
		}
		else
		{
			$retval = false;
		}
	}
	else
	{
		$subscriberEmail = $GLOBALS['BAB_SESS_EMAIL'];
	}

	$tableWrapper->setTableName($tableName);
	return $retval;
}


function buildSubscriptionURL(& $subscriptionInfo, $type, $subscriberID, $topicID)
{
	switch($type)
	{
		case UNSUBSCRIPTION_CONFIRMATION_URL_FOR_SEND:
			$subscriptionInfo['unsubcribe_txt'] = nl_translate("unsubscription");
			$subscriptionInfo['unsubcribe_url'] = nl_url() . 'users&idx=unsubscribe&sub_id=_IDSUB_&id=' . $topicID; 
			break;
			
		case UNSUBSCRIPTION_CONFIRMATION_URL:
			$subscriptionInfo['unsubcribe_txt'] = nl_translate("unsubscription");
			$subscriptionInfo['unsubcribe_url'] = nl_url() . 'users&idx=unsubscribe&sub_id=' 
				. $subscriberID . '&id=' . $topicID; 
			break;

		case SUBSCRIPTION_CONFIRMATION_URL:
			$subscriptionInfo['confirmation_txt'] = nl_translate("To confirm your subscription please click on this link");
			$subscriptionInfo['confirmation_url'] = nl_url().'users&idx=subscribe&sub_id=' . 
				$subscriberID . '&id=' . $topicID;
			break;

		default:
			break;
	}
}






/* 
	User function:
		L'utisateur courant soumet les infos de desabonnement
		 une newsletter
*/
function processUserUnsubcription()
{
/*	
// Tester l'email sinon reposter
//	'email' => $_POST['email'],
*/	
	processUnsubcription();
}

function processUnsubcription()
{
	$tableWrapper = new TableWrapper(NL_SUBSCRIBERS);

	$topicID = (isset($_GET['id']) ? $_GET['id'] : $_POST['id']);
	$usrLoggedIn = bab_userIsloggedin() && !bab_isAccessValid(NL_INSCRIPTION_GROUP, $topicID);
	
	$ret = unsubscribe2nl($usrLoggedIn, $tableWrapper);
	if(SHOW_QUIT_MSG === $ret['retVal'])
	{
		$subscriberID = $ret['subscriber']['id'];
		$quitEmail = buildQuitEmail($topicID, $subscriberID, $usrLoggedIn, $tableWrapper);
		if(false === $tableWrapper->delete($ret['subscriber']))
		{
			$GLOBALS['babBody']->msgerror = nl_translate("Error subscriber not deleted");
		}
		else if(false != $quitEmail)
		{
			$susbcription2Send = new SendSubscriptionInfo($quitEmail);

			$emailSended = $susbcription2Send->send();

			$GLOBALS['g_idx'] = '';

			$msg = nl_translate("You have been removed from the newsletter ") . $quitEmail['name'] . 
				((true === $emailSended) ? nl_translate(" a message have been sent to :") . $quitEmail['email']
				 : '');

			showMsg($quitEmail['name'], $msg);

			if(false === $emailSended)
			{
				$GLOBALS['babBody']->msgerror = nl_translate("Error while attempting to send a quit message");
			}
		}
	}
	else if(SHOW_CONFIRM_UNSUBCRIPTION_MSG === $ret['retVal'])
	{
		$subscriberID = $ret['subscriber']['id'];
		$confirmationEmail = buildUnsubcriptionConfirmationEmail($topicID, $subscriberID, $usrLoggedIn, $tableWrapper);

		if(false != $confirmationEmail)
		{
			$susbcription2Send = new SendSubscriptionInfo($confirmationEmail);
			if(true === $susbcription2Send->send())
			{
				$GLOBALS['g_idx'] = '';

				$msg = nl_translate("To confirm your unsubcription to the newsletter ") . $confirmationEmail['name'] . 
					nl_translate(" please respond to the message that have been sent to :") . $confirmationEmail['email'];

				showMsg($confirmationEmail['name'], $msg);

				$subscriber = array('id' => $subscriberID, 'subscription' => UNSUBSCRIPTION_TO_CONFIRME);

				$tableWrapper->setTableName(NL_SUBSCRIBERS);
				if(false === $tableWrapper->update($subscriber))
				{
					$GLOBALS['babBody']->msgerror = 
						nl_translate("The unsubscription process has failed, please contact the administrator");
				}
			}
			else
			{
				$GLOBALS['babBody']->msgerror = 
					nl_translate("The unsubscription confirmation email was not sent, please retry or contact the administrator");
			}
		}
	}
}

//Peux tre appel par POST ou GET
//Doit retourner le message  afficher
function unsubscribe2nl($usrLoggedIn, & $tableWrapper)
{
	$selectParam = 0;
	$whereParam = 0;

	$retVal = array('retVal' => ERROR, 'subscriber' => array());

	$tableName = $tableWrapper->getTableName();

	$newsletterTopic = array('id' => (isset($_POST['id']) ? $_POST['id'] : $_GET['id']),
		'unsubscription_validation' => -1);

	$tableWrapper->setTableName(NL_NEWSLETTER_TOPIC);
	$newsletterTopic = $tableWrapper->load($newsletterTopic, 0, 2, 0, 1);
	if(false !== $newsletterTopic)
	{
		$tableWrapper->setTableName(NL_SUBSCRIBERS);

		if(true == $usrLoggedIn)
		{
			//Desenregistrement d'un utilisateur loggu
			$retVal['subscriber'] = array(
				'id_ov_user' => $GLOBALS['BAB_SESS_USERID'], 
				'id_newsletter_topic' => $newsletterTopic['id'],
				'subscription' => SUBSCRIPTION_CONFIRMED,
				'id' => 0);

			$selectParam = 4;
			$whereParam = 3;

			$retVal['retVal'] = SHOW_QUIT_MSG;
		}
		else if( isset($_GET['sub_id']) )
		{
			//Confirmation de desenregistrement d'un utilisateur non loggu ou loggu
			//ou desenregistrement sans avoir confirm
			$retVal['subscriber'] = array(
				//'id_ov_user' => 0,
				'id' => $_GET['sub_id'],
				'id_newsletter_topic' => $newsletterTopic['id']);

			$whereParam = $selectParam = 2;
			$retVal['retVal'] = SHOW_QUIT_MSG;
		}
		else
		{
			//Desenregistrement d'un utilisateur non loggu
			$retVal['subscriber'] = array(
				'id_ov_user' => 0, 
				'id_newsletter_topic' => $newsletterTopic['id'], 
				'email' => nl_escapeString($_POST['email']),
				'subscription' => -1,
				'id' => -1); 

			$selectParam = 5;
			$whereParam = 3;

			if(UNSUBSCRIPTION_NOT_NEEDED == $newsletterTopic['unsubscription_validation'])
			{
				$retVal['retVal'] = SHOW_QUIT_MSG;
			}
			else if(UNSUBSCRIPTION_NEEDED == $newsletterTopic['unsubscription_validation'])
			{
				$retVal['retVal'] = SHOW_CONFIRM_UNSUBCRIPTION_MSG;
			}
			else
			{
				$retVal['retVal'] = ERROR;
			}
		}
		
		$retVal['subscriber'] = $tableWrapper->load($retVal['subscriber'], 0, $selectParam, 0, $whereParam);

		//Desenregistrement dja effectu ?
		if( false === $retVal['subscriber'] )
		{
			$GLOBALS['babBody']->msgerror = nl_translate("You are not a subscriber of this newsletter");
			$retVal['retVal'] = ERROR;
		}
		else if( false == $usrLoggedIn && !isset($_GET['sub_id']) )
		{
			//Desenregistrement d'un utilisateur non loggu
			//pour eviter de spammer
			if(UNSUBSCRIPTION_TO_CONFIRME == $retVal['subscriber']['subscription'])
			{
				$retVal['retVal'] = ERROR;
				$GLOBALS['babBody']->msgerror = nl_translate("To terminate the unsubscription process please respond to the email that have been sent");
			}
		}
	}
	else
	{
			$GLOBALS['babBody']->msgerror = 
				nl_translate("Error in unsubcription process : cannot load the newsletter topic informations");
			$retVal['retVal'] = ERROR;
	}

	$tableWrapper->setTableName($tableName);
	return $retVal;
}

function buildQuitEmail($topicID, $subscriberID, $usrLoggedIn, & $tableWrapper)
{
	$error = false;

	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_NEWSLETTER_TOPIC);

	$subscriptionInfo = array(
		'id' => $topicID,
		'name' => '',
		'quit_subject' => '',
		'quit_body' => '',
		'admin_email' => '',
		'admin_name' => ''
	);

	$subscriptionInfo = $tableWrapper->load($subscriptionInfo, 0, 6, 0, 1);

	if(false !== $subscriptionInfo)
	{
		$subscriptionInfo['subject'] = $subscriptionInfo['quit_subject'];
		$subscriptionInfo['body'] = $subscriptionInfo['quit_body'];

		unset($subscriptionInfo['quit_subject']);
		unset($subscriptionInfo['quit_body']);

		$subscriptionInfo['unsubcribe_txt'] = '';
		$subscriptionInfo['unsubcribe_url'] = ''; 

		$subscriptionInfo['confirmation_txt'] = '';
		$subscriptionInfo['confirmation_url'] = '';

		$email = '';
		if(false === getSubscriberEmail($usrLoggedIn, $subscriberID, $tableWrapper, $email))
		{
			$error = true;
		}
		else
		{
			$subscriptionInfo['email'] = $email;
		}
	}

	$tableWrapper->setTableName($tableName);

	if(false === $error)
	{
		return $subscriptionInfo;
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("Cannot built the unsubscription message");
		return false;
	}
}

function buildUnsubcriptionConfirmationEmail($topicID, $subscriberID, $usrLoggedIn, & $tableWrapper)
{
	$error = false;

	$tableName = $tableWrapper->getTableName();
	$tableWrapper->setTableName(NL_NEWSLETTER_TOPIC);

	$subscriptionInfo = array('id' => $topicID, 'name' => '',
		'admin_name' => '', 'admin_email' => '',
		'unsubscription_body' => '', 'unsubscription_subject' => '');

	$subscriptionInfo = $tableWrapper->load($subscriptionInfo, 0, 6, 0, 1);

	if(false != $subscriptionInfo)
	{
		$subscriptionInfo['subject'] = $subscriptionInfo['unsubscription_subject'];
		$subscriptionInfo['body'] = $subscriptionInfo['unsubscription_body'];
		
		unset($subscriptionInfo['unsubscription_subject']);
		unset($subscriptionInfo['unsubscription_body']);

		$subscriptionInfo['confirmation_txt'] = '';
		$subscriptionInfo['confirmation_url'] = '';

		buildSubscriptionURL($subscriptionInfo, UNSUBSCRIPTION_CONFIRMATION_URL,
			$subscriberID, $topicID);

		$email = '';
		if(false === getSubscriberEmail($usrLoggedIn, $subscriberID, $tableWrapper, $email))
		{
			$error = true;
		}
		else
		{
			$subscriptionInfo['email'] = $email;
		}
	}
	else
	{
		$error = true;
	}


	if(false === $error)
	{
		return $subscriptionInfo;
	}
	else
	{
		$GLOBALS['babBody']->msgerror = nl_translate("Cannot built the unsubscription confirmation message");
		return false;
	}

}

?>