<?php

require_once(dirname(__FILE__) . '/nlincl.php');
require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');
require_once(dirname(__FILE__) . '/manager.php'); 
require_once(dirname(__FILE__) . '/writer.php'); 
require_once(dirname(__FILE__) . '/user.php');


/*
	Ajoute des menus en fonction du profile de l'utilisateur
	interactif.
	L'utilisateur interactif peut tre un ou une conbinaison
	de : Manager, Writer, Use
*/
function addDefaultMenu()
{
	global $babBody;

	$menuSelected = '';

	$usrAccess = getUserAccess();

	if( MANAGER == ($usrAccess & MANAGER) )
	{
		$babBody->addItemMenu('mgrlist', nl_translate("Management"), nl_url().'users&idx=mgrlist');

		if('' === $menuSelected)
		{
			$menuSelected = 'mgrlist';
		}
	}

	if( WRITER == ($usrAccess & WRITER) )
	{
		$babBody->addItemMenu('wrtlist', nl_translate("Writing"), nl_url().'users&idx=wrtlist');

		if('' === $menuSelected)
		{
			$menuSelected = 'wrtlist';
		}
	}
	
	if( USER == ($usrAccess & USER) )
	{
		//$babBody->addItemMenu('usrlist', nl_translate("Subscribe"), nl_url().'users&idx=usrlist');
		//$babBody->addItemMenu('listSubscribedNl', nl_translate("Unsubscribe"), nl_url().'users&idx=listSubscribedNl');

		$babBody->addItemMenu('displayNewsletterList', nl_translate("Newsletter list"), nl_url().'users&idx=displayNewsletterList');
		
		if('' === $menuSelected)
		{
			$menuSelected = 'usrlist';
		}
	}

	return $menuSelected;
}

function nl_inscriptionGroup(){
	
	global $babBody;
	
	$babBody->title = nl_translate("Define newsletter add-on suscribers and how to");
	
	$macl = new macl('addon/newsletter'.'/users', "defaultMenu", $_GET['id'], 'aclview');
	$macl->addtable(NL_USERS_GROUP, nl_translate("Define newsletter add-on suscribers"));
	$macl->filter(0, 0, 0, 0, 0);
	$macl->addtable(NL_INSCRIPTION_GROUP, nl_translate("Define newsletter add-on suscribers which must enter their email address and their name for suscrib"));
	$macl->filter(0, 0, 1, 0, 1);

	
	$macl->babecho();
	
	addDefaultMenu();
	$babBody->addItemMenu($_GET['idx'], nl_translate("Define right"), nl_url().'users');
}

// ----------------------------------------------------------------------- //
// Traitemant de formulaire
// ----------------------------------------------------------------------- //

/* main */
$g_idx = isset($_POST['idx']) ? $_POST['idx'] : (isset($_GET['idx']) ? $_GET['idx'] : 'defaultMenu');

if(isset($_POST['aclview']))
{
	maclGroups();
}
else if(isset($_GET['action']) && 'writedletterdeletionconfirmed' == $_GET['action'])
{
	processDeleteWritedLetter();
}
else
{
	$action = '';

	if( isset($_POST['action']) )
	{
		$action = $_POST['action'];
		//echo 'action ==> ' . $action . '<br />' ;
	}

	switch($action)
	{
		case 'udateTopic':
			if(false == processEditNewsletter())
			{
				$g_idx = 'edit';
			}
			break;

		case 'subscribe':
			processUserSubcription();
			break;

		case 'unsubscribe':
			processUserUnsubcription();
			break;

		case 'ImportExportUsers':
			if(false == processImportExportUsers())
			{
				$g_idx = 'ImportExportUsers';
			}
			break;

		case 'ImportUsers':
			if(false == processImportUsers())
			{
				//$g_idx = 'ImportExportUsers';
			}
			break;

		case 'editlh':
		case 'editlf':
			processEditLetter($action);
			break;

		case 'deleteSubscriber':
			deleteSubscriber();
			break;

		/* The writer want to save/send a letter */
		case 'Send':
		case 'Save':
			if(false === processEditWriteLetter($action))
			{
				$g_idx = 'writeletter';
			}
			break;
		case 'Prev':
			$id = processEditWriteLetter($action);
			if($id)
			{
				$_GET['draft'] = 'Y';
				$_GET['id_letter'] = $id;
				$_GET['id_newsletter_topic'] = $_POST['id_newsletter_topic'];
				$_GET['prev'] = '1';
				$_POST = NULL;
			}
			$g_idx = 'writeletter';
			break;
	}
}

switch($g_idx)
{
	/* Manager */
	case 'mgrlist': /* A virer utiliser defaultMenu  la place */
		listManagerNewsletters();
		break;

	/* Manager */
	case 'edit':
		editNewsletter();
		break;

	/* Manager */
	case 'aclWriter':
		setGroup(NL_WRITERS_GROUP, nl_translate("Define newsletter add-on writers"));
		break;

	/* Manager */
	case 'aclUser':
		nl_inscriptionGroup();
		break;

	/* Manager */
	case 'ImportExportUsers':
		ImportExportUsers();
		break;

	/* Manager */
	case 'editlf':
	case 'editlh':
		editLetters($_GET['idx']);
		break;

	/* Manager */
	case 'listSubscribers':
		listSubscribers();
		break;

	/* Manager : permet de specifier faire de la recherche avance pour 'listSubscribers' */
	case 'advanced_research':
		display_advanced_research_form();
		break;
	
	/* Writer */
	case 'wrtlist':
		listWriterNewsletters();
		break;

	case 'listDraftLetters':
		listDraftletters();
		break;
		
	case 'listSendedLetters':
		listSendedLetters();
		break;
		
	case 'okSendLetter':
		nl_okSendLetter();
		break;
		
	case 'listToLetter':
		nl_listToLetter();
		break;

	/* Writer */
	case 'writeletter':
		writeEditletter();
		break;

	/* Writer */
	case 'deletewritedletter':
		deleteWritedLetter();
		break;

	/* Writer */
	case 'sendwritedletter':
		SendWritedLetter();
		break;

	/* User */
	/*	
	case 'usrlist':
		listUserNewsletters();
		break;
	//*/
		
	/* User */
	/*
	case 'listSubscribedNl':
		listSubscribedNewsletter();
		break;
	//*/

	/* User */
	case 'displayNewsletterList':
		displayNewsletterList();
		break;
		
	case 'subscribe':
		subscribe($g_idx);
		break;

	case 'unsubscribe':
		unsubscribe($g_idx);
		break;

	/* Selectionne le menu en fonction du profil de l'utilisateur interactif */
	case 'defaultMenu':
		$g_idx = addDefaultMenu();

		if('mgrlist' === $g_idx)
		{
			listManagerNewsletters();
		}
		else if('wrtlist' === $g_idx)
		{
			listWriterNewsletters();
		}
		else if('usrlist' === $g_idx)
		{
			displayNewsletterList();
		}
		break;

	default:
		break;
}

$babBody->setCurrentItemMenu($g_idx);

?>