<?php
require_once($GLOBALS['babInstallPath'].'admin/acl.php');
require_once(dirname(__FILE__) . '/nlincl.php');
require_once(dirname(__FILE__) . '/defines.php');
require_once(dirname(__FILE__) . '/newsletter.php');


/* 
	Writer function:
		Liste toutes les newsletters pour lesquelles 
		l'utilisateur courant est un rdacteur
*/
function listWriterNewsletters()
{
	$query =
		'SELECT ' . 
			'nl.id, ' .
			'name, ' .
			'description ' .
		'FROM ' . 
			NL_NEWSLETTER_TOPIC . ' nl ' .
		'WHERE ' .
			'nl.id IN(\'' . implode("','", array_keys(bab_getUserIdObjects(NL_WRITERS_GROUP))) . '\') AND ' .
			'nl.disabled != 1 ' .
		'ORDER BY ' . 
			'name ' .
		'ASC';

	//echo $query . '<br />';

	$nl_addonInfo = nl_addonInfo();
	
	$newsletters = new NewsletterInfo($query);

	$newsletters->set_anchor(nl_url() . 'users&idx=writeletter&draft=Y&id_newsletter_topic=',
		$nl_addonInfo->getImagesPath() . '16x16/document-edit.png',
		nl_translate("Write a new letter")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=listDraftLetters&id_newsletter_topic=',
		$nl_addonInfo->getImagesPath() . '16x16/editor.png',
		nl_translate("List all draft letter")
	);
	$newsletters->set_anchor(nl_url() . 'users&idx=listSendedLetters&id_newsletter_topic=',
		$nl_addonInfo->getImagesPath() . '16x16/mail-folder-inbox.png',
		nl_translate("List all sended letter")
	);


	global $babBody;
	$babBody->title = nl_translate("Newsletter that you are writer");

	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('edit_url', nl_url() . 'users&idx=writeletter&draft=Y&id_newsletter_topic=');

	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'common.html', 'nlList'));

	addDefaultMenu();
}


function listLetter($draft, $templateName)
{
	$userGprList = implodeUserGroup(',');

	$query ='SELECT DISTINCT nl.id id_newsletter_topic, nl.name, nl.description, letter.id id_letter,'.
			'		letter.id_writer id_writer, letter.subject, letter.creation_date'  .
					((true === $draft) ? '' : ', letter.date_envoi') .
			'	FROM ' . NL_NEWSLETTER_TOPIC . ' nl' . 
			'	LEFT JOIN ' . NL_LETTERS . ' letter ON letter.id_newsletter_topic = nl.id' .
			'		AND letter.date_envoi IS ' . ((true === $draft) ? 'NULL' : 'NOT NULL') .
			'  WHERE nl.disabled != 1 ' . ' AND nl.id = ' . $_GET['id_newsletter_topic'] . 
				 ' AND letter.id IS NOT NULL ORDER BY name asc';
	
	bab_debug($query);

	$newsletters = new WriterLetterInfo($query);

	$newsletters->set_anchor(nl_url() .'users&idx=writeletter&'.
				'draft=' . ((true === $draft) ? 'Y' : 'N'),
			$GLOBALS['babSkinPath'] . 'images/Puces/FileWrite.gif',
			nl_translate("Edit"));
	$newsletters->set_anchor(nl_url() .'users&idx=deletewritedletter&',
			$GLOBALS['babSkinPath'] . 'images/Puces/del.gif',
			nl_translate("Delete this letter"));

	$newsletters->set_caption('name', nl_translate("Name"));
	$newsletters->set_caption('description', nl_translate("Description"));
	$newsletters->set_caption('subject', nl_translate("Subject"));
	$newsletters->set_caption('creation_date', nl_translate("Created"));
	$newsletters->set_caption('date_envoi',  nl_translate("Sended"));
	$newsletters->set_caption('edit_url', nl_url() . 'users&idx=writeletter&' . 'draft=' . ((true === $draft) ? 'Y' : 'N'));

	global $babBody;
	$babBody->title = $newsletters->getTitle();

	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'writer.html', $templateName));

	addDefaultMenu();
}

/* 
	Writer function:
		Liste toutes les newsletters pour lesquelles 
		l'utilisateur courant est un writer
*/
function listDraftletters()
{
	listLetter(true, 'nlList');
}


function nl_listToLetter()
{
	require_once dirname(__FILE__).'/set/subscribers.class.php';
	require_once dirname(__FILE__).'/set/letter_subscribers.class.php';
	require_once dirname(__FILE__).'/ui/writer.ui.php';
	
	$W = bab_Widgets();
	
	$page = $W->BabPage();
	$page->setTitle(nl_translate('List of user which should recieved the newsletter'));
	
	addDefaultMenu();
	
	$id = bab_gp('id', '');
	
	if($id){
		$set = new nl_letter_subscribersSet();
		$set->id_subscribers();
		
		$subscribers = $set->select($set->id_letter->is($id));
	}
	
	if(!$id || $subscribers->count() == 0){
		$page->addItem($W->Label(nl_translate('No user record.')));
	}else{
		$list = new nl_letter_subscribersTableView;
		$list->setDataSource($subscribers);
		$list->addDefaultColumns($set);
		$page->addItem($list);
	}
	
	echo $page->display($W->HtmlCanvas());
	die;
}

function nl_okSendLetter()
{
	$W = bab_Widgets();
	
	$page = $W->BabPage();
	$page->setTitle(nl_translate('Send in progress'));
	
	addDefaultMenu();
	
	$page->addItem(
		$W->FlowItems(
			$W->Label(nl_translate('Your newsletter sending is in progress. If you want to see the status click')),
			$W->Link(nl_translate('here'), nl_url() . 'users&idx=listToLetter&id=' . bab_gp('id'))->addAttribute('target', '_blank'),
			$W->Label('.')
		)->setHorizontalSpacing(.25, 'em')
	);
	
	$page->displayHtml();
}

function listSendedletters()
{
	class temp
	{	
		var $res;
		
		function temp(){
			global $babBody, $babDB;
			
			$userGprList = implodeUserGroup(',');
		
			$query ='SELECT DISTINCT nl.id id_newsletter_topic, nl.name, nl.description, letter.id id_letter, '.
					'		letter.id_writer id_writer, letter.subject, letter.creation_date, letter.date_envoi '  .
					'FROM nl_newsletter_topic as nl ' . 
					'LEFT JOIN nl_letter as letter ON letter.id_newsletter_topic = nl.id ' .
					'WHERE nl.disabled != 1 ' .
					'AND nl.id = ' . $_GET['id_newsletter_topic'] . ' '.
					'AND letter.date_envoi IS NOT NULL ' .
					'AND letter.id IS NOT NULL ORDER BY name asc';
			
			$this->res = $babDB->db_query($query);
			$this->count = $babDB->db_num_rows($this->res);			
		
			$this->m_captions['name'] = nl_translate("Name");
			$this->m_captions['description'] = nl_translate("Description");
			$this->m_captions['subject'] = nl_translate("Subject");
			$this->m_captions['creation_date'] = nl_translate("Created");
			$this->m_captions['date_envoi'] = nl_translate("Sended");
			$this->m_captions['edit_url'] = nl_url() . 'users&idx=writeletter&draft=N';
			
			$babBody->title = nl_translate("No letter for this newsletter");
		}
		
		function getNextRow(){
			global $babBody, $babDB;
			$nl_addonInfo = nl_addonInfo();
			while($arr = $babDB->db_fetch_array($this->res)){
				$babBody->title = nl_translate($arr['name']) . ':' . nl_translate($arr['description']);
				
				$this->m_datas['subject'] 				= $arr['subject'];
				$this->m_datas['creation_date']			= $arr['creation_date'];
				$this->m_datas['date_envoi'] 			= $arr['date_envoi'];
				$this->m_datas['url'] 					= nl_url();
				$this->m_datas['skin'] 					= $nl_addonInfo->getImagesPath();
				$this->m_datas['id_letter'] 			= $arr['id_letter'];
				$this->m_datas['id_newsletter_topic'] 	= $arr['id_newsletter_topic'];
				$this->m_datas['t_list_user']		 	= nl_translate("Subscribers list status.");
				$this->m_datas['t_edit']		 		= nl_translate("Edit");
				$this->m_datas['t_remove'] 				= nl_translate("Delete this letter");
				$this->m_datas['b_retry']				= false;
				
				return true;
			}
			return false;
		}

	}
	global $babBody;
	$newsletters = new temp();
	
	//$babBody->title = $newsletters->getTitle();
	
	$babBody->babecho(bab_printTemplate($newsletters, nl_relativePath().'writer.html', 'nlList2'));

	addDefaultMenu();
}


/* 
	Writer function:
		Ecriture d'une lettre, puis soumission
*/
function writeEditletter()
{
	
	class BaseFormProcessingWriter extends BaseFormProcessing
	{
		function BaseFormProcessingWriter(){
			parent::BaseFormProcessing();
		}
	}
	
	$nl_db = new nlDB();
	$query = '';
	$attributs = array();
	$baseFormProcessing = new BaseFormProcessingWriter();

	/* jQuery */
	$jquery = bab_functionality::get('jquery');
	$jquery->includeCore();
	$jquery->includeUi();
	
	if(true === isset($_GET['id_letter']))
	{
		$query = 'SELECT DISTINCT nl.id id_newsletter_topic, nl.template as template, nl.patron as patron, nl.name, nl.letter_header, nl.letter_footer, letter.id id, letter.subject, letter.body' .
			'	FROM ' . NL_NEWSLETTER_TOPIC. ' nl ' .
			'	LEFT JOIN ' . NL_LETTERS . ' letter ON letter.id =' . $_GET['id_letter'] .
			' WHERE nl.id = ' . $_GET['id_newsletter_topic'];

		$result = $nl_db->m_db->db_query($query);
		$attributs = $nl_db->db_fetch_assoc($result); 
	}
	else
	{
		$query = 'SELECT DISTINCT nl.id id_newsletter_topic, nl.name, nl.letter_header, nl.letter_footer, nl.template, nl.patron' .
			'	FROM ' . NL_NEWSLETTER_TOPIC . ' nl ' .
			'WHERE nl.id = ' . ((isset($_GET['id_newsletter_topic'])) ? $_GET['id_newsletter_topic'] : $_POST['id_newsletter_topic']);

		$result = $nl_db->m_db->db_query($query);
		$attributs = $nl_db->db_fetch_assoc($result); 

		if(true === isset($_POST['id']))
		{
			$baseFormProcessing->set_data('id', $_POST['id']);
			$baseFormProcessing->set_data('subject', nl_stripSlashes($_POST['subject']));
			$baseFormProcessing->set_data('body', nl_stripSlashes($_POST['newsletter_body']));
		}
		else
		{
			$baseFormProcessing->set_data('id', NEWSLETTER_NONE);
			$baseFormProcessing->set_data('subject', '');
			if($attributs['template']){				
				$file = "newsletter_template.html";
				if( !file_exists( "skins/".$GLOBALS['babSkin']."/templates/". $file ) )
				{
					$filepath = nl_relativePath(). $file;
				} else {
					$filepath = $file;
				}
				class nl_empty {}
				$empty = new nl_empty();
				$message = bab_printTemplate($empty, $filepath, $attributs['template']);
				$baseFormProcessing->set_data('body', $message);
			}
		}
	}
	
	
	if(ISSET($_GET['oversize']) && $_GET['oversize'] == '1'){
		$baseFormProcessing->set_caption('oversize_b', true);
	}else{
		$baseFormProcessing->set_caption('oversize_b', false);
	}
	$baseFormProcessing->set_caption('oversize_t', nl_translate("You mail is over the maximum size."));

	if(ISSET($_GET['prev']) && $_GET['prev'] == '1'){
		$baseFormProcessing->set_caption('prev_b', true);
	}
	
	if(ISSET($_GET['realprev']) && $_GET['realprev'] == '1'){
		class temp
		{
			function temp($attributs)
			{
				$this->header = $attributs["letter_header"];
				$this->body = $attributs["body"];
				$this->footer = $attributs["letter_footer"];
				$this->unsubcribe = nl_translate("unsubscription");;
				$this->unsubcribe_url = '';
			}
		}
		/*for template var*/
		$templateVar = new temp($attributs);
		
		$file = "newsletter_patron.html";
		if( !file_exists( "skins/".$GLOBALS['babSkin']."/templates/". $file ) )
		{			
			$filepath = nl_relativePath(). $file;
		} else {
			$filepath = $file;
		}
		
		$message = bab_printTemplate($templateVar, $filepath, $attributs['patron']);
		echo $message;
		die;
	}
	
	$baseFormProcessing->set_data('draft', ((isset($_GET['draft'])) ? $_GET['draft'] : $_POST['draft']));
	$baseFormProcessing->set_caption('subject', nl_translate("Subject"));
	$baseFormProcessing->set_caption('format', nl_translate("Format"));
	$baseFormProcessing->set_caption('html', nl_translate("HTML"));
	$baseFormProcessing->set_caption('text', nl_translate("TEXT"));
	$baseFormProcessing->set_caption('header', nl_translate("Header"));
	$baseFormProcessing->set_caption('body', nl_translate("Body"));
	$baseFormProcessing->set_caption('footer', nl_translate("Footer"));
	$baseFormProcessing->set_caption('invalide body', nl_translate("The field body is empty"));
	$baseFormProcessing->set_caption('action', nl_translate("Action"));
	$baseFormProcessing->set_caption('save', nl_translate("Save"));
	$baseFormProcessing->set_caption('send', nl_translate("Send"));
	$baseFormProcessing->set_caption('prev', nl_translate("Save & preview"));
	$baseFormProcessing->set_caption('sendInfo', nl_translate("The sending can take severals minute. You must wait until the process is ended."));

	$baseFormProcessing->set_data('save', 'Save');
	$baseFormProcessing->set_data('send', 'Send');
	$baseFormProcessing->set_data('prev', 'Prev');

	$baseFormProcessing->set_error('subject', nl_translate("The field subject must not be empty"));
	//Suppression du test sur le corps car selon l'diteur wysiwyg, newsletter_body n'est pas toujours ditable
	//$baseFormProcessing->set_error('newsletter_body', nl_translate("The field body must not be empty"));

	$baseFormProcessing->implode_errors(',',true);


	if(false !== $attributs)
	{
		while(list($key, $val) = each($attributs)) 
		{
			$baseFormProcessing->set_data($key, $val);
		}
	}

	// get the body before raw_2_html
	$body = '';
	$letterHeader = '';
	$letterFooter = '';
	$baseFormProcessing->get_data('body', $body);
	$baseFormProcessing->get_data('letter_header', $letterHeader);
	$baseFormProcessing->get_data('letter_footer', $letterFooter);
	
	$baseFormProcessing->raw_2_html(RAW_2_HTML_DATA);
	$baseFormProcessing->raw_2_html(RAW_2_HTML_CAPTION);

	$baseFormProcessing->set_data('letter_header_displayed', $letterHeader);
	$baseFormProcessing->set_data('letter_footer_displayed', $letterFooter);
	
	require_once $GLOBALS['babInstallPath']."utilit/editorincl.php";
	$editor = new bab_contentEditor('newsletter_body');
	$editor->setFormat('email');
	$editor->setContent($body);
	$baseFormProcessing->set_data('body', $editor->getEditor());
	
	global $babBody;
	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath().'writer.html', "writeletter"));

	$babBody->title = nl_translate("Selected newsletter : ") . $attributs['name'];

	addDefaultMenu();
	$babBody->addItemMenu('writeletter', nl_translate("Compose a new message"), nl_url().'user');
}


function deleteWritedLetter()
{
	global $babBody;

	$baseFormProcessing = new BaseFormProcessing();

	$baseFormProcessing->set_caption('msg', nl_translate("Are you sure you want to delete this letter ? :"));
	$baseFormProcessing->set_caption('warning', ' ');
	$baseFormProcessing->set_caption('yes', nl_translate("Yes"));
	$baseFormProcessing->set_caption('no', nl_translate("No"));
	$baseFormProcessing->set_caption('newsletterName', nl_translate("lettre ID = ") . $_GET['id_letter']);
	$baseFormProcessing->set_caption('id', $_GET['id_letter']);

	$babBody->babecho(bab_printTemplate($baseFormProcessing, nl_relativePath()."writer.html",  "warningyesno"));
}

function SendWritedLetter()
{

//$log = new logFile('SendEmail.txt');

	if(NBR_OF_EMAIL_2_SEND == $_GET['what'])
	{

/*
$log->write('SendWritedLetter : ' . 'NBR_OF_EMAIL_2_SEND');
$log->write("\r\n");
*/
		$db = new nlDB();

		$query = 'SELECT COUNT(*) email2Send FROM ' . NL_SUBSCRIBERS .
			' WHERE id_newsletter_topic = ' . $_GET['nlID'] . 
				' AND subscription = \'' . SUBSCRIPTION_CONFIRMED . '\'';
/*
$log->write($query);
$log->write("\r\n");

$msg = 'SendWritedLetter : ' . '$toSend[\'email2Send\'] = ' . $toSend['email2Send'];
$log->write($msg);
$log->write("\r\n");
*/
		$result = $db->db_query($query);
		$toSend = $db->db_fetch_assoc($result);

		$url = 'location:' . nl_url() . 
					'users&idx=sendwritedletter&nlID=' . $_GET['nlID'] .
					'&letterID=' . $_GET['letterID'] . '&what=' . SEND_EMAIL .
					'&email2Send=' . $toSend['email2Send'] . '&offset=0';
/*
$msg = 'SendWritedLetter : ' . '$url = ' . $url;
$log->write($msg);
$log->write("\r\n");
*/
		header($url);
	}
	else if(SEND_EMAIL == $_GET['what'])
	{
/*
$log->write('SendWritedLetter : ' . 'SEND_EMAIL');
$log->write("\r\n");
*/
			$sendLetter = new SendLetter();
			$sendLetter->sendEmail();
	}
	else if(SEND_EMAIL_TERMINATED == $_GET['what'])
	{
/*
$log->write('SendWritedLetter : ' . 'TERMINATED');
$log->write("\n\r");
*/
		$url = 'location:' . nl_url() . 'users&idx=wrtlist';

		header($url);
	}
	else
	{

	}
}


function processEditWriteLetter($action)
{
/*
	$log = new logFile('SendEmail.txt');
	$log->write('processEditWriteLetter : ' . $action);
	$log->write("\r\n");
*/

	if(true === bab_userIsloggedin())
	{
		$erreur = false;

		$tableWrapper = new TableWrapper(NL_LETTERS);

		$attributs = array(
			'id_newsletter_topic' => $_POST['id_newsletter_topic'],
			'id_writer' => $GLOBALS['BAB_SESS_USERID'],
			'subject' => nl_escapeString($_POST['subject']),
			'body' => nl_escapeString($_POST['newsletter_body'])
			);

			//'Y' == $_POST['draft']	=> lettre avec date_envoi == NULL 
			//'N' == $_POST['draft']	=> lettre avec date_envoi != NULL 
			//NEWSLETTER_NONE == $_POST['id']		=> creation
			//NEWSLETTER_NONE != $_POST['id']		=> edition

			//Que l'on envoie ou que l'on sauvegarde il faut sauver
			//donc par default on sauvegarde
/*
			$log->write('processEditWriteLetter draft = ' . $_POST['draft'] . ' id = ' . $_POST['id']);
			$log->write("\r\n");
*/
			if( ('Y' == $_POST['draft'] && NEWSLETTER_NONE == $_POST['id']) ||		/* creation jamais envoye */
				('N' == $_POST['draft'] && NEWSLETTER_NONE != $_POST['id'])	)	/* edition deja envoye */
			{
				if(false === $tableWrapper->load($attributs, 0, 4, 0, 4))
				{
					$attributs['creation_date'] = 'now()';
					$result = $tableWrapper->save($attributs, false, true);
					if(true === $result)
					{
						$attributs['id'] = $tableWrapper->m_db->m_db->db_insert_id(); 
						/*
						$log->write('processEditWriteLetter [Last inserted id = ' . $attributs['id'] . ']');
						$log->write("\r\n");
						*/
						if('Save' === $action){
							return true;
						}elseif('Prev' === $action){
							return $attributs['id'];
						}
					}
					else
					{
						$erreur = true;
						$GLOBALS['babBody']->msgerror = nl_translate("Error the letter cannot be saved");
						/*
						$log->write('processEditWriteLetter [ERROR WHILE SAVING]');
						$log->write("\r\n");
						*/
						return false;
					}
				}
				else
				{
					$erreur = true;
					$GLOBALS['babBody']->msgerror = nl_translate("The letter was not saved because an identical letter exist");
					/*
					$log->write('Lettre non sauvegarde car une autre avec un contenu identique existe');
					$log->write("\r\n");
					*/
					return false;
				}
			}
			else if( 'Y' == $_POST['draft'] && NEWSLETTER_NONE != $_POST['id'] )	/* edition jamais envoye */
			{
				$attributs['id'] = $_POST['id'];
				$result = $tableWrapper->update($attributs, false);
				if(false === $result)
				{
					$erreur = true;
					$GLOBALS['babBody']->msgerror = nl_translate("The letter was not saved because an error was encounter");
					return false;
				}
				if('Save' === $action || 'Prev' === $action){
					return $attributs['id'];
				}
			}
			else
			{
				$erreur = true;
				/*
				$log->write('processEditWriteLetter Save error');
				$log->write("\r\n");
				*/
			}
				
			if('Send' === $action && false === $erreur)
			{
				if(0 < getNumberOfSuscriber($_POST['id_newsletter_topic']))
				{
					$attributs['date_envoi'] = 'now()';
					$result = $tableWrapper->update($attributs, true);

					if(true === $result)
					{
						/*
						$log->write('processEditWriteLetter [Lettre id = ' . $attributs['id'] . ' sended]');
						$log->write("\r\n");
						*/
						header('location:' . nl_url() . 
							'users&idx=sendwritedletter&nlID=' . $_POST['id_newsletter_topic'] .
							'&letterID=' . $attributs['id'] . '&what=' . NBR_OF_EMAIL_2_SEND);
						/*
						$log->write('processEditWriteLetter : NBR_OF_EMAIL_2_SEND');
						$log->write("\r\n");
						*/
					}
					else
					{
						$GLOBALS['babBody']->msgerror = nl_translate("Cannot update the letter, letter not sended however you can edit it again");
						/*
						$log->write('processEditWriteLetter [Last inserted id = ' . $attributs['id'] . 'ERROR not sended]');
						$log->write("\r\n");
						*/
						return true;
					}
				}
				else
				{
					$GLOBALS['babBody']->msgerror = nl_translate("The letter was saved but not sended because there is no suscriber");
					/*
					$log->write('processEditWriteLetter : Lettre non envoye mais sauvegarde car aucun abonn');
					$log->write("\r\n");
					*/
					return true;
				}
			}
	}
	else
	{
		/*
		$log->write('processWriteLetter ERROR');
		$log->write("\r\n");
		*/
		$GLOBALS['babBody']->msgerror = nl_translate("You must be logged to write/send a letter");
		return true;
	}
}

function processDeleteWritedLetter()
{
	$attributs = array('id' => $_GET['id']);
	$newsLetter = new	TableWrapper(NL_LETTERS);
	$newsLetter->delete($attributs, 0, 1);
	
	
	require_once dirname(__FILE__).'/set/subscribers.class.php';
	require_once dirname(__FILE__).'/set/letter_subscribers.class.php';
	$set = new nl_letter_subscribersSet();
	
	$set->delete($set->id_letter->is($_GET['id']));
}

function getNumberOfSuscriber($id_newsletter_topic)
{
	$nl_db = new nlDB();

	$query = 'SELECT count(*) count' .
		'	FROM ' . NL_SUBSCRIBERS .
		' WHERE subscription = \'' . SUBSCRIPTION_CONFIRMED . '\' AND id_newsletter_topic =' . $id_newsletter_topic;

//echo $query . '<BR />';

	$result = $nl_db->m_db->db_query($query);
	$attributs = $nl_db->db_fetch_assoc($result); 

	if(false != $attributs)
	{
		return $attributs['count'];
	}
	return 0;
}
?>